/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 *	
 *	Copyright (C) 2011-2012 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN  
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *	
 */

/*
 *	SH72AW CPUܡɤΥϡɥ񸻤
 */

#ifndef TOPPERS_SH72AW_H
#define TOPPERS_SH72AW_H

/*
 *  åϢΥ쥸
 *  åΥϡᥤ󥯥å20MHz or PLL120MHz160MHz
 *  ʬơCPUΥåȤSCDR
 *  ʬơХåBCDRˡյǽåABȤPBCDR
 */
#define SPR0 0xff46e063 /* ƥץƥȥ쥸 */
#define SPR0_CANCEL_PROTECT 0xf1 /* ץƥȲ */
#define SPR0_PROTECT 0x00 /* ץƥ(0xF1ʳ) */

#define MCMCR 0xff46e838 /* ᥤ󥯥åƻ뵡ǽ쥸 */
#define MCMCR_LXDF_MASK 0x04 /* ᥤ󥯥åȯߤ򸡽Ф */
#define MCMCR_LXIE 0x01 /* ᥤ󥯥åȯ߸гߤ */

#define PLCR 0xff46e828 /* PLL쥸 */
#define PLCR_VCOD 0x0001 /* PLLνϡ120MHzʤΥӥåȤ0ˤȡ160MHz*/

#define SCSR 0xff46e802 /* ƥ९å쥸 */
#define SCSR_SCS_PLL 0x01 /* PLL */
#define SCSR_SCS_XIN 0x00 /* ᥤ󥯥å */

#define SCDR 0xff46e804 /* ƥ९åʬ쥸 */
#define SCDR_SYSD_DIV0 0x00 /* ʬʤ */
#define SCDR_SYSD_DIV2 0x01 /* 2ʬ */
#define SCDR_SYSD_DIV4 0x02 /* 4ʬ */
#define SCDR_SYSD_DIV8 0x03 /* 8ʬ */
#define SCDR_SYSD_DIV16 0x04 /* 16ʬ */

#define BCDR 0xff46e805 /* Хå */
#define BCDR_BUSD_DIV2 0x10 /* 2ʬ */
#define BCDR_BUSD_DIV4 0x20 /* 4ʬ */

#define PBCDR 0xff46e808 /* յǽåʬ쥸 */
#define PBCDR_PBAD_DIV2 0x10000000 /* åA2ʬ */
#define PBCDR_PBAD_DIV4 0x20000000 /* åA4ʬ */
#define PBCDR_PBBD_DIV0 0x00000000 /* åBʬʤ */
#define PBCDR_PBBD_DIV2 0x00000100 /* åB2ʬ */

#define RDCCR 0xff46e80c /* RDCå쥸f(PBA)ʬ */
#define RDCCR_RDCD_DIV0 0x00 /* ʬʤ */
#define RDCCR_RDCD_DIV2 0x01 /* 2ʬ */

#define COCR 0xff46e800 /* åϵǽ쥸f(BUS)ʬ */
#define COCR_COD_DIV0 0x00 /* ʬʤ */
#define COCR_COD_DIV2 0x10 /* 2ʬ */
#define COCR_COD_DIV4 0x20 /* 4ʬ */
#define COCR_COD_DIV8 0x30 /* 8ʬ */
#define COCR_COD_DIV16 0x40 /* 16ʬ */
#define COCR_COE 0x01 /* f(CLKOUT)ϤʤΥӥåȤ0ˤȽϤʤ*/

#define MSTPCR 0xff46e850 /* ⥸塼륹ȥå쥸 */
#define MSTPCR_FPUSTP 0x0001 /* FPUߡʺƤư뤿ˤϥꥻåȤ*/

#endif /* TOPPERS_SH72AW_H */
