/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 *	
 *	Copyright (C) 2011-2012 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *	
 */

/*
 *	åȰ¸⥸塼SH2A-MG-EVBѡ
 */

#include "kernel_impl.h"
#include <sil.h>
#include "sh72aw.h"
#include "target_serial.h"
#include "task.h"
#include "memory.h"

/*
 *	åȰ¸ν
 */
void
target_initialize(void)
{
	/*
	 *	ץå¸ν
	 */
	prc_initialize();

    /*
     *  MPUν
     */
    target_mpu_initialize();

	/*
	 *  ٥ѤΥꥢ륳ȥν
	 */
    target_fput_initialize();
}

/*
 *	åȰ¸νλ
 */
void
target_exit(void)
{
	/*
	 *	ץå¸νλ
	 */
	prc_exit();

	/*
	 *	ȯĶ¸νλ
     *	äˤʤ
	 */
    while(1);

	/*
	 * ˤʤ
	 */
	while(1);
}

/*
 *  ٥ѥꥢݡȤν
 */
void
target_fput_initialize(void)
{
    SIOPCB *p_siopcb = &(siopcb_table[TARGET_PUTC_PORTID - 1]);
    const SIOPINIB *p_siopinib = &(siopinib_table[TARGET_PUTC_PORTID - 1]);

    if(!(p_siopcb->initialized_flag)){
        p_siopcb->initialized_flag = true;

        sio_hardware_initialize(p_siopinib);
    }
}

/*
 *	ƥ٥ϤΤʸ
 */
Inline void
sio_send_char_pol(char c)
{
    const SIOPINIB *p_siopinib = &(siopinib_table[TARGET_PUTC_PORTID - 1]);
    SIL_PRE_LOC;

    /*
     *  ХåեޤԤ
     */
    while((sil_reb_mem(p_siopinib->scsr) & SCI_SR_TBEF) == 0);

    /*
     *  ¾νñ̤ХåեȤʤ褦ˡ
     *  ߤػߤ
     */
    SIL_LOC_INT();
    
    /*
     *  Хåեʸ񤭹
     */
    sil_wrb_mem(p_siopinib->sctb, (uint8_t)c);

    /*
     *  ߶ػߤ
     */
    SIL_UNL_INT();
}

void
target_fput_log(char c)
{
	if (c == '\n') {
		sio_send_char_pol('\r');
	}
    sio_send_char_pol(c);
}

/*
 *	׵饤°
 */
void
x_config_int(INTNO intno, ATR intatr, PRI intpri)
{
    uint16_t set_icr;

	assert(VALID_INTNO_CFGINT(intno));
	assert((-15 <= intpri) && (intpri <= TMAX_INTPRI));

	/*
	 *	öߤػߤ
	 */
	(void)x_disable_int(intno);

    /*
     *  ͥ٤ȳߵ
     */
    set_icr = (intatr & TA_ENAINT)? INTC_PB_ICR_INTEN: 0U;
    intpri *= -1; // +-ȿž
    set_icr |= ((uint16_t)intpri & INTC_PB_ICR_IPR_MASK);

    sil_wrh_mem((void *)(INTC_PB_ICR_BASE + (intno - INTC_PB_INTNO_BASE) * 2), set_icr);

}

/*
 *  ΰ褬桼åΰ˴ޤޤƤ뤫Υå
 *
 *  ƬϤbaseǥsizeΥΰ褬p_tcbǻꤵ륿
 *  Υ桼åΰ˴ޤޤƤtrueǤʤ
 *  false֤
 *
 *  ΰƬϤ桼åޤǤĹ
 *  ΰΥ礭ġ
 *  桼åΥ⾮Сΰϡ
 *  桼åϰǤ롥
 *
 */
bool_t
within_ustack(const void *base, SIZE size, TCB *p_tcb)
{
    SIZE stk_bottom = (SIZE)(p_tcb->p_tinib->tskinictxb.stk_bottom);
    SIZE len = stk_bottom - (SIZE)base;

    return ((SIZE)base < stk_bottom
            && len >= size
            && len <= (SIZE)(p_tcb->p_tinib->tskinictxb.stksz));
}

/*
 *  桼Υ㳰ƤӽФ
 *  Ѥ륹å­ʤ
 */
bool_t
i_check_tex_runtsk()
{
    SIZE ustk_top = (SIZE)(p_runtsk->tskctxb.usp);

    if(!PROBE_STACK((void *)(ustk_top - USRTEX_STKSZ), 
                USRTEX_STKSZ)){
        return (true);
    }

    return (false);
}  

