/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 *	
 *	Copyright (C) 2011-2012 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *	
 */

/*
 *	åȰ¸⥸塼SH2A-MG_EVBѡ
 *
 *	ͥΥåȰ¸Υ󥯥롼ɥե롥kernel_impl.hΥ
 *	åȰ¸ΰդȤʤ롥
 */

#ifndef TOPPERS_TARGET_CONFIG_H
#define TOPPERS_TARGET_CONFIG_H

#include <sil.h>

/*
 *	åȥƥΥϡɥ񸻤
 */
#include "sh72aw.h"

#include "target_mpu.h"

/*
 *	ȥ졼˴ؤ
 */
#ifdef TOPPERS_ENABLE_TRACE
#include "logtrace/trace_config.h"

/*
 *	Ϥ̤
 *	ɬפ˱asp/arch/logtrace/trace_dump.ctrace_print()
 *	б̤ɵ롣
 */
#define LOG_INH_ENTER			/*	 17(0x11)  */
#define LOG_INH_LEAVE			/*	145(0x91)  */
#define LOG_EXC_ENTER			/*	 22(0x16)  */
#define LOG_EXC_LEAVE			/*	150(0x96)  */

#endif /* TOPPERS_ENABLE_TRACE */

/*
 *  cfgΥѥ2ɬפȤʤޥ
 */
#define TARGET_INTATR (TA_POSEDGE | TA_NEGEDGE | TA_LOWLEVEL)
#define CHECK_STKSZ_ALIGN 4

/*
 *  cfgΥѥ3ɬפȤʤޥ
 */
#define CHECK_FUNC_ALIGN  2
#define CHECK_FUNC_NONNULL  1
#define CHECK_STACK_ALIGN  4
#define CHECK_STACK_NONNULL 1
#define CHECK_MPF_ALIGN 4
#define CHECK_MPF_NONNULL 1

/*
 *	åȰ¸ʸϤ˻ѤݡȤ
 */
#define TARGET_PUTC_PORTID 1

/*
 *	HRPͥưΥޥåפȴϢ
 */

/*
 *  RAM0xFFF8 0000 - 0xFFF8 7FFF(32KB) <- ꥻåȸ
 *       0xFFF8 0000 - 0xFFF9 7FFF(96KB)
 */

/*
 *	ǥեȤ󥿥ƥѤΥåΰ
 */
/*  å  */
#define DEFAULT_ISTKSZ 0x800U /* 2048Х */

/*	åΰ */
#define DEFAULT_ISTK_BOTTOM 0xfff88000 /* RAM */

/*	åΰƬϡʥåΰǤϤʤΤǡա */
#define DEFAULT_ISTK	  (void *)(DEFAULT_ISTK_BOTTOM - DEFAULT_ISTKSZ)

#ifndef TOPPERS_MACRO_ONLY

#define DEFAULT_SSTKSZ 1280 

/*
 *	ƥȥ֥å
 */

#define USE_TSKINICTXB	/*  TSKINICTXBѤ  */

typedef struct task_initialization_context_block {
	SIZE	sstksz;			/* åΰΥʴݤ᤿͡ */
	void	*sstk_bottom;	/* åݥ󥿤ν͡ʥåν͡ */
	SIZE	stksz;			/* åΰΥʴݤ᤿͡ */
	void	*stk_bottom;	/* åݥ󥿤ν͡ʥåν͡ */
    void    *sustk; /* 桼åƬ */
    void    *eustk; /* 桼åνλ */
} TSKINICTXB;

/*
 *  ݸɥᥤƥȥ֥å
 */

#define USE_DOMINICTXB	/*  TSKINICTXBѤ  */

typedef struct {
    void *stext;
    void *etext;
    void *srodata;
    void *erodata;
    void *sdata;
    void *edata;
    void *ssrpw;
    void *esrpw;
    uint32_t *valid_map;
} DOMINICTXB;

/*
 *  桼ø⡼ɼ¹椫
 *  priv_modeϡӥ롢ӡĥӥ
 *  true˥åȤ
 */
#define t_sense_priv(p_tcb) ((p_tcb)->tskctxb.priv_mode)
#define i_sense_priv(p_tcb) ((p_tcb)->tskctxb.priv_mode)
#define t_sense_priv_runtsk() ((p_runtsk)->tskctxb.priv_mode)
#define i_sense_priv_runtsk() ((p_runtsk)->tskctxb.priv_mode)

#define USRTEX_STKSZ 16

/*
 *  桼Υ㳰ƤӽФ˻Ѥ륹å­ʤ
 *  i_check_tex_runtskϡ󥿥ƥȤƤФΤǡ
 *  桼åTCB¸ƤϤǤ
 */
extern bool_t i_check_tex_runtsk();

/*
 *	åȥƥ¸ν
 */
extern void target_initialize(void);
extern void target_fput_initialize(void);
extern void target_fput_log(char c);

/*
 *	åȥƥνλ
 *
 *	ƥλ˻Ȥ
 */
extern void target_exit(void) NoReturn;

/*
 * CPU㳰ֹ˴ؤ
 */
#define TMIN_EXCNO		UINT_C(4)		/*	GENERAL_ILLEGAL_INSTRUCTION_VECTOR	*/
#define TMAX_EXCNO		UINT_C(63)		/*	TRAPA_INST_VECTOR  */
#define TNUM_EXC		(TMAX_EXCNO - TMIN_EXCNO + 1U)

/*
 *	㳰٥
 */
#define POWER_ON_RESET_VECTOR				0
#define MANUAL_RESET_VECTOR					2
#define GENERAL_ILLEGAL_INSTRUCTION_VECTOR	4
#define RAM_ERROR_VECTOR					5
#define SLOT_ILLEGAL_INSTRUCTION_VECTOR		6
#define CPU_ADDRESS_ERROR_VECTOR			9
#define DMA_ADDRESS_ERROR_VECTOR			10
#define FPU_VECTOR							13
#define BANK_OVER_FLOW_VECTOR				15
#define BANK_UNDER_FLOW_VECTOR				16
#define DIVIDE_BY_ZERO_VECTOR				17


/*
 * ߥϥɥֹ˴ؤ
 */
#define TMIN_INHNO		UINT_C(64)
#define TMAX_INHNO		UINT_C(493)
#define TNUM_INH		(TMAX_INHNO - TMIN_INHNO + 1U)

/*
 * ֹ˴ؤ
 */
#define TMIN_INTNO		UINT_C(64)
#define TMAX_INTNO		UINT_C(493)
#define TNUM_INT		(TMAX_INTNO - TMIN_INTNO + 1U)

/*	IRQ  */
#define TMIN_INTNO_IRQ 	64U
#define TMAX_INTNO_IRQ	71U

/*
 *  ߴϢΥ쥸
 */
#define INTC_BCR 0xfffd940e /* Х쥸 */
#define INTPRI2BCR(intpri) (0x0001 << (uint16_t)intpri) /* ͥ٤BCRꤹͤޥ */
#define INTC_BNR 0xfffd9410 /* Хֹ쥸 */
#define INTC_BNR_BE_DISABLE_ALL  0x0000 /* ٤ƤγߤǥХ󥯤ػ */
#define INTC_BNR_BE_DISABLE_PART 0x4000 /* ᥤ󥯥åȯߡ桼֥졼Τߵ */
#define INTC_BNR_BE_BCR 0xC000 /* BCR˽ */

/*
 *  յǽֹΥ١
 *  peripheral block
 */
#define INTC_PB_INTNO_BASE 102

/*
 *  յǽ׵쥸Υ١ɥ쥹
 *  1byte
 */
#define INTC_PB_IR_BASE 0xfffd9800

/*
 *  յǽ쥸Υ١ɥ쥹
 *  2byte
 */
#define INTC_PB_ICR_BASE 0xfffd999a
#define INTC_PB_ICR_INTEN 0x8000    /* ߵġʥӥåȤ0ʤжػߡ */
#define INTC_PB_ICR_IPR_MASK 0x000f /* ͥ٤Υޥ */

/*	CFG_INTǳͥ٤ꤵƤʤȤ򼨤ӥå  */
#ifndef NOT_CFG_INT_BIT
#define NOT_CFG_INT_BIT		0x80U
#endif /* NOT_CFG_INT_BIT */

extern const uint8_t int_iipm_tbl[TNUM_INT];


/*
 *  ׵Υå
 */
Inline bool_t 
x_probe_int(INTNO intno)
{
    return ((sil_reb_mem((void *)(INTC_PB_IR_BASE + (intno - INTC_PB_INTNO_BASE))) & 0x01) == 0x01);
}

#define t_probe_int(intno) x_probe_int(intno)
#define i_probe_int(intno) x_probe_int(intno)

/*
 *  ׵Υꥢ
 */
Inline void
x_clear_int(INTNO intno)
{
    sil_wrb_mem((void *)(INTC_PB_IR_BASE + (intno - INTC_PB_INTNO_BASE)), 0x00);
}

#define t_clear_int(intno) x_clear_int(intno)
#define i_clear_int(intno) x_clear_int(intno)

/*
 *  ߶ػ
 */
Inline bool_t
x_disable_int(INTNO intno)
{
    uint8_t iipm = int_iipm_tbl[intno - TMIN_INTNO];

    if((iipm & NOT_CFG_INT_BIT) != 0){
        return false;
    }

    sil_wrh_mem((void *)(INTC_PB_ICR_BASE + (intno - INTC_PB_INTNO_BASE) * 2), 
            (sil_reh_mem((void *)(INTC_PB_ICR_BASE + (intno - INTC_PB_INTNO_BASE) * 2)) & ~INTC_PB_ICR_INTEN));

    return true;
}

#define t_disable_int(intno) x_disable_int(intno)
#define i_disable_int(intno) x_disable_int(intno)

/*
 *  ߵ
 */
Inline bool_t
x_enable_int(INTNO intno)
{
    uint32_t iipm = int_iipm_tbl[intno - TMIN_INTNO];

    if((iipm & NOT_CFG_INT_BIT) != 0){
        return false;
    }

    sil_wrh_mem((void *)(INTC_PB_ICR_BASE + (intno - INTC_PB_INTNO_BASE) * 2), 
            (sil_reh_mem((void *)(INTC_PB_ICR_BASE + (intno - INTC_PB_INTNO_BASE) * 2)) | INTC_PB_ICR_INTEN));

    return true;
}

#define t_enable_int(intno) x_enable_int(intno)
#define i_enable_int(intno) x_enable_int(intno)


#endif /* TOPPERS_MACRO_ONLY */

/*
 *	ԤΤSILΥåȰ¸
 */
#define SIL_DLY_TIM1    30 /* 160MHzǡ5̿ */
#define SIL_DLY_TIM2    24 /* 160MHzǡ4̿ */

/*
 *  ߵĤͭˤʤޤǤλԤ򤹤뤿nop̿
 *  
 *  SH7211ϰŪʥå¢Ƥʤˡ
 *  ¢եåROMФƤΤͭROMå
 *  ¢Ƥ롣ROMåϾONǡOFFˤϤǤʤ
 *  ΤᡢENABLE_CACHEޥǤϤʤROM_BOOTޥ
 *  Ѥơٱɬפ̿Ƚ̤Ƥ롣
 */
#ifdef ROM_BOOT		/*  ROMåαƶ  */
	/*
	 *  ROMåθ̤θ
	 *  CPUINTCãޤǤٱ
	 *  ʥѥ3Icycʬ6̿ 
	 */

	/*  ǥѥå  */
#define LDC_NOP_DISPATCHER		nop; nop; nop; nop; nop; nop

	/*  set_srѡΥåȤǤɬפʤ  */
// #define LDC_NOP_SET_SR			"nop; nop"

	/*  TOPPERS_set_iipmѤtarget_sil.h˵Ҥ롣  */

#endif	/*  ROM_BOOT  */

/*
 *	μ
 */
#define SH2A

/*
 *	ѤǤ̿᥻å
 *	SH1̿ˤĤƤϡ٤ƤΥǥݡȤΤǡ
 *	ʤ
 */
#define TOPPERS_SUPPORT_SH2_INSTRUCTION
#define TOPPERS_SUPPORT_SH2E_INSTRUCTION
#define TOPPERS_SUPPORT_SH2A_INSTRUCTION

#ifndef TOPPERS_TARGET_SUPPORT_OVRHDR
#define TOPPERS_TARGET_SUPPORT_OVRHDR
#endif /* TOPPERS_TARGET_SUPPORT_OVRHDR */

/*
 *	IRQߤɤȽꤹ뤿Υޥ
 *	prc_config.h٤Υեx_config_intatr()
 *	ǻѤ뤿ᡢ˵ҤƤ롣
 */
#define INTNO_IS_IRQ(intno) 								\
		((TMIN_INTNO_IRQ <= (intno)) && ((intno) <= TMAX_INTNO_IRQ))

/*
 *	ֹ椫IRQֹؤѴ
 */
#define INTNO_TO_IRQNO(intno) (((intno) - TMIN_INTNO_IRQ))

#define TEXCNO_EMULATE_TEXRTN 20
#define TEXCNO_EMULATE_RET_TEX 21

#ifndef TOPPERS_MACRO_ONLY

#include <sil.h>

/*
 * IRCν
 */
Inline void
irc_initialize(void)
{
    /*
     *  ٤ƤγߤǥХ󥯤ػ
     */
    sil_wrh_mem((void *)INTC_BNR, INTC_BNR_BE_DISABLE_ALL);
}

/*
 *	ߥϥɥɬפIRC
 *
 *	IRQߤǤĥåȥꥬξϳ׵򥯥ꥢ롥
 *	åȥꥬ٥ȥꥬȽ̤ȥСإåɤ礭Τǡ
 *	˥ꥢ롥
 *	ʥ٥ȥꥬǥꥢ򤷤ƤⳲϤʤ
 *
 *	IRQRR쥸١ߡ꡼ɤơ ӥåȤ0񤭹ࡣ
 *	δ֡ߥå֤ˤƤΤϡʲΤ褦ʥɤ
 *	ᡣ
 *
 *	3γߤͤ롣
 *	ͥ٤ϡl > m > nνȤ롣
 *	ʳlͥ٤⤤
 *	
 *	1.	mγߤȯ(mӥåȤå)
 *	2.	mγߥϥɥ餬¹(nϳ߶ػ)
 *	3.	IRQRR꡼(l = 0, m = 1, n = 0)
 *	4.	lγߤȯ(lӥåȤå)
 *	5.	lγߥϥɥ餬¹(nϳ߶ػ)
 *	6.	nγߤȯα(nӥåȤå)
 *	7.	IRQRR꡼(l = 1, m = 1, n = 1)
 *	8.	IRQRR饤(l = 0, m = 1, n = 1)
 *	9.	lγߥϥɥ齪λ
 *	10. mγߥϥɥƳ
 *	11. IRQQ饤(l = 0, m = 0, n = 0)
 *	
 *	11ʳ n ꥢǽ롥
 */
Inline void
i_begin_int(INTNO intno)
{
}

extern void target_mpu_initialize(void);
extern void target_mpu_handler(void);

#endif /* TOPPERS_MACRO_ONLY */

#include "sh12a_gcc/prc_config.h"

#endif	/* TOPPERS_TARGET_CONFIG_H */
