/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 *	
 *	Copyright (C) 2011-2012 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *	
 */

/*
 *	MPUɥ饤СSH72AWѡ
 */

#include "kernel_impl.h"
#include <sil.h>
#include "kernel_cfg.h"
#include "target_mpu.h"

extern char _vector_start;
extern char _vector_end;
extern char _vector_entry_start;
extern char _vector_entry_end;

void
target_mpu_initialize(void)
{
    char *shared_mem_start;
    char *shared_mem_end;

    /*
     *  ΰ5: ͭtext
     */
    shared_mem_start = shared_meminib_table[0];
    shared_mem_end   = shared_meminib_table[1];
    sil_wrw_mem((void *)(MPCSADR5), (uint32_t)shared_mem_start);
    sil_wrw_mem((void *)(MPCEADR5), (uint32_t)shared_mem_end);

    /*
     *  ΰ6: ͭrodata
     */
    shared_mem_start = shared_meminib_table[2];
    shared_mem_end   = shared_meminib_table[3];
    sil_wrw_mem((void *)(MPCSADR6), (uint32_t)shared_mem_start);
    sil_wrw_mem((void *)(MPCEADR6), (uint32_t)shared_mem_end);

    /*
     *  ΰ7: ͭdata
     */
    shared_mem_start = shared_meminib_table[4];
    shared_mem_end   = shared_meminib_table[5];
    sil_wrw_mem((void *)(MPCSADR7), (uint32_t)shared_mem_start);
    sil_wrw_mem((void *)(MPCEADR7), (uint32_t)shared_mem_end);

    /*
     *  ΰ8: ͭ꡼ѥ饤ΰ
     */
    shared_mem_start = shared_meminib_table[6];
    shared_mem_end   = shared_meminib_table[7];
    sil_wrw_mem((void *)(MPCSADR8), (uint32_t)shared_mem_start);
    sil_wrw_mem((void *)(MPCEADR8), (uint32_t)shared_mem_end);

    /*
     *  ΰ9٥ơ֥
     */
    sil_wrw_mem((void *)(MPCSADR9), (uint32_t)&_vector_start);
    sil_wrw_mem((void *)(MPCEADR9), (((uint32_t)(&_vector_end) + 3) & 0xfffffffc) - 4);

    /*
     *  ΰ10٥ȥ
     */
    sil_wrw_mem((void *)(MPCSADR10), (uint32_t)&_vector_entry_start);
    sil_wrw_mem((void *)(MPCEADR10), (((uint32_t)(&_vector_entry_end) + 3) & 0xfffffffc) - 4);

    /*
     *  ΰ11MPUͭ쥸
     */
    sil_wrw_mem((void *)(MPCSADR11), (uint32_t)MPCMPEN);
    sil_wrw_mem((void *)(MPCEADR11), (uint32_t)MPCMPEN);

    /*
     *  R
     */
    sil_wrw_mem((void *)(MPCRACR), (uint32_t)(0xaaaa07f7));

    /*
     *  W
     */
    sil_wrw_mem((void *)(MPCWACR), (uint32_t)(0xaaaa089c));

    /*
     *  I(X)
     */
    sil_wrw_mem((void *)(MPCIACR), (uint32_t)(0xaaaa0421));

}

void
target_mpu_exc_handler(void *p_excinf)
{
    syslog(LOG_EMERG, "MPU EXCEPTION OCCURED!!");
    while(1);
}

// 㳰¹Գϻåϥɥ
void
target_emulate_texrtn_handler(void *p_excinf)
{
    syslog(LOG_EMERG, "User stack is no space at prepare texrtn.");
    while(1);
}

// 㳰꥿åϥɥ
void
target_emulate_ret_tex_handler(void *p_excinf)
{
    syslog(LOG_EMERG, "User stack is no space at return texrtn.");
    while(1);
}


/*
 *  ꤵ줿ɥ쥹桼⡼ɻ˽߲ǽå
 */
#ifdef OMIT_PROBE_MEM_WRITE
bool_t
probe_mem_write(void *base, SIZE size)
{
	uint32_t top;

    /*
     *  Ƭɥ쥹򥵡
     */
    sil_wrw_mem((void *)MPCRSADR, (uint32_t)base); /* 륢ɥ쥹򥻥å*/
    sil_wrb_mem((void *)MPCRSOP,  (uint8_t)MPCRSOP_S_BIT);  /* ΰ襵򳫻 */

	/* 
     *  Ƭɥ쥹Υ̤¸
     */
	top = sil_rew_mem((void *)MPCHITO);

	/* 
     *  ߲ǽå
     */
	if((top & MPCHITO_W_MASK) == 0){
		return false;
	}

    /*
     *  λɥ쥹򥵡
     */
    sil_wrw_mem((void *)MPCRSADR, (uint32_t)(base + size)); /* 륢ɥ쥹򥻥å*/
    sil_wrb_mem((void *)MPCRSOP,  (uint8_t)MPCRSOP_S_BIT);  /* ΰ襵򳫻 */

	/* 
     *  Ƭɥ쥹Υ̤Ȱפ뤫ɤå
     */
	if(sil_rew_mem((void *)MPCHITO) != top){
        return false;
    }

	return true;
}
#endif /* OMIT_PROBE_MEM_WRITE */

/*
 *  ꤵ줿ɥ쥹桼⡼ɻɹ߲ǽå
 */
#ifdef OMIT_PROBE_MEM_READ
bool_t
probe_mem_read(void *base, SIZE size)
{
	uint32_t top;

    /*
     *  Ƭɥ쥹򥵡
     */
    sil_wrw_mem((void *)MPCRSADR, (uint32_t)base); /* 륢ɥ쥹򥻥å*/
    sil_wrb_mem((void *)MPCRSOP,  (uint8_t)MPCRSOP_S_BIT);  /* ΰ襵򳫻 */

	/* 
     *  Ƭɥ쥹Υ̤¸
     */
	top = sil_rew_mem((void *)MPCHITO);

	/* 
     *  ɤ߽Фǽå
     */
	if((top & MPCHITO_R_MASK) == 0){
		return false;
	}

    /*
     *  λɥ쥹򥵡
     */
    sil_wrw_mem((void *)MPCRSADR, (uint32_t)(base + size)); /* 륢ɥ쥹򥻥å*/
    sil_wrb_mem((void *)MPCRSOP,  (uint8_t)MPCRSOP_S_BIT);  /* ΰ襵򳫻 */

	/* 
     *  Ƭɥ쥹Υ̤Ȱפ뤫ɤå
     */
	if(sil_rew_mem((void *)MPCHITO) != top){
        return false;
    }

	return true;
}
#endif /* OMIT_PROBE_MEM_READ */

/*
 *  ꤵ줿ΰ褬桼åΰ˼ޤäƤ뤫å
 */
#ifdef OMIT_PROBE_STACK

bool_t
probe_stack(void *base, SIZE size)
{
	if((sil_rew_mem((void *)MPCSADR4) <= (uint32_t)base) &&
	   (sil_rew_mem((void *)MPCEADR4) >= (uint32_t)((SIZE)base + size))){
		return true;
	}

	return false;
}
#endif /* OMIT_PROBE_STACK */


