/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 *	
 *	Copyright (C) 2011 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *	
 */

/*
 *	ꥢI/OǥХSIO˥ɥ饤СSH2A-MG-EVBѡ
 *	SCI0 
 */

#include "kernel/kernel_impl.h"
#include <t_syslog.h>
#include <sil.h>
#include "target_serial.h"

const SIOPINIB siopinib_table[TNUM_SCI_PORT] = {
#if TNUM_SCI_PORT > 0
    {
        (void *)(SCI0_BASE + OFFSET_SCI_CR),     /* 쥸 */
        (void *)(SCI0_BASE + OFFSET_SCI_MD),     /* ⡼ɥ쥸 */
        (void *)(SCI0_BASE + OFFSET_SCI_EMD),    /* ĥ⡼ɥ쥸 */
        (void *)(SCI0_BASE + OFFSET_SCI_BR),     /* ӥåȥ졼ȥ쥸 */
        (void *)(SCI0_BASE + OFFSET_SCI_TB),     /* Хåե쥸 */
        (void *)(SCI0_BASE + OFFSET_SCI_RB),     /* Хåե쥸 */
        (void *)(SCI0_BASE + OFFSET_SCI_SR),     /* ơ쥸 */
        (void *)(PIO_PA10CR),  /* RXDüҤΥݡ쥸 */
        (void *)(PIO_PA11CR),  /* TXDüҤΥݡ쥸 */
        (void *)(PIO_PA12CR),  /* SCKüҤΥݡ쥸 */
        (void *)(PIO_PAIN),    /* RXDüҤΥݡϥ쥸 */
        (10),          /* RXDбPIOֹ桧A/Bθο */
        (INTNO_SCI0_RXF), /* Хåեեγֹ */
        (INTNO_SCI0_TXC), /* λγֹ */
    },
#endif /* TNUM_SCI_PORT > 0 */
#if TNUM_SCI_PORT > 1
    {
        (void *)(SCI1_BASE + OFFSET_SCI_CR),     /* 쥸 */
        (void *)(SCI1_BASE + OFFSET_SCI_MD),     /* ⡼ɥ쥸 */
        (void *)(SCI1_BASE + OFFSET_SCI_EMD),    /* ĥ⡼ɥ쥸 */
        (void *)(SCI1_BASE + OFFSET_SCI_BR),     /* ӥåȥ졼ȥ쥸 */
        (void *)(SCI1_BASE + OFFSET_SCI_TB),     /* Хåե쥸 */
        (void *)(SCI1_BASE + OFFSET_SCI_RB),     /* Хåե쥸 */
        (void *)(SCI1_BASE + OFFSET_SCI_SR),     /* ơ쥸 */
        (void *)(PIO_PA13CR),  /* RXDüҤΥݡ쥸 */
        (void *)(PIO_PA14CR),  /* TXDüҤΥݡ쥸 */
        (void *)(PIO_PA15CR),  /* SCKüҤΥݡ쥸 */
        (void *)(PIO_PAIN),    /* RXDüҤΥݡϥ쥸 */
        (13),          /* RXDбPIOֹ桧A/Bθο */
        (INTNO_SCI1_RXF), /* Хåեեγֹ */
        (INTNO_SCI1_TXC), /* λγֹ */
    },
#endif /* TNUM_SCI_PORT > 1 */
#if TNUM_SCI_PORT > 2
    {
        (void *)(SCI2_BASE + OFFSET_SCI_CR),     /* 쥸 */
        (void *)(SCI2_BASE + OFFSET_SCI_MD),     /* ⡼ɥ쥸 */
        (void *)(SCI2_BASE + OFFSET_SCI_EMD),    /* ĥ⡼ɥ쥸 */
        (void *)(SCI2_BASE + OFFSET_SCI_BR),     /* ӥåȥ졼ȥ쥸 */
        (void *)(SCI2_BASE + OFFSET_SCI_TB),     /* Хåե쥸 */
        (void *)(SCI2_BASE + OFFSET_SCI_RB),     /* Хåե쥸 */
        (void *)(SCI2_BASE + OFFSET_SCI_SR),     /* ơ쥸 */
        (void *)(PIO_PB02CR),  /* RXDüҤΥݡ쥸 */
        (void *)(PIO_PB03CR),  /* TXDüҤΥݡ쥸 */
        (void *)(PIO_PB04CR),  /* SCKüҤΥݡ쥸 */
        (void *)(PIO_PBIN),    /* RXDüҤΥݡϥ쥸 */
        (2),          /* RXDбPIOֹ桧A/Bθο */
        (INTNO_SCI2_RXF), /* Хåեեγֹ */
        (INTNO_SCI2_TXC), /* λγֹ */
    },
#endif /* TNUM_SCI_PORT > 2 */
#if TNUM_SCI_PORT > 3
    // PIOֹϡꥻåȸ 
    {
        (void *)(SCI3_BASE + OFFSET_SCI_CR),     /* 쥸 */
        (void *)(SCI3_BASE + OFFSET_SCI_MD),     /* ⡼ɥ쥸 */
        (void *)(SCI3_BASE + OFFSET_SCI_EMD),    /* ĥ⡼ɥ쥸 */
        (void *)(SCI3_BASE + OFFSET_SCI_BR),     /* ӥåȥ졼ȥ쥸 */
        (void *)(SCI3_BASE + OFFSET_SCI_TB),     /* Хåե쥸 */
        (void *)(SCI3_BASE + OFFSET_SCI_RB),     /* Хåե쥸 */
        (void *)(SCI3_BASE + OFFSET_SCI_SR),     /* ơ쥸 */
        (void *)(PIO_PA06CR),  /* RXDüҤΥݡ쥸 */
        (void *)(PIO_PA07CR),  /* TXDüҤΥݡ쥸 */
        (void *)(PIO_PA08CR),  /* SCKüҤΥݡ쥸 */
        (void *)(PIO_PAIN),    /* RXDüҤΥݡϥ쥸 */
        (6),          /* RXDбPIOֹ桧A/Bθο */
        (INTNO_SCI3_RXF), /* Хåեեγֹ */
        (INTNO_SCI3_TXC), /* λγֹ */
    },
#endif /* TNUM_SCI_PORT > 3 */
};

SIOPCB siopcb_table[TNUM_SCI_PORT];

/*
 *	SIOɥ饤Фν
 */
void
sio_initialize(intptr_t exinf)
{
    SIOPCB *p_siopcb;
    int8_t i;

    for(i = 0, p_siopcb = &(siopcb_table[0]); i < TNUM_SCI_PORT; i++, p_siopcb++){
        p_siopcb->p_siopinib = &(siopinib_table[i]);
    }
}

void
sio_hardware_initialize(const SIOPINIB *p_siopinib)
{
    /*
     *  ݡ쥸ϡ
     */
    sil_wrb_mem((void *)PIO_PPR, PIO_PPR_UNPROTECT); /* ץƥȤβ */

    /* Ϥġݡȵǽϼյǽ */
    sil_wrh_mem(p_siopinib->rxdiocr, (PIO_CR_INE | PIO_CR_PSEL_IO));

    sil_wrb_mem((void *)PIO_PPR, 0); /* ץƥ */

    /*
     *  ػ
     */
    sil_wrb_mem(p_siopinib->sccr,
                (sil_reb_mem(p_siopinib->sccr) & ~(SCI_CR_TE | SCI_CR_RE)));

    /*
     *  å 
     */
    sil_wrb_mem(p_siopinib->sccr,
                ((sil_reb_mem(p_siopinib->sccr) & ~(SCI_CR_CKS_MASK)) | (SCI_CR_CKS)));

    /*
     *  ⡼ɥ쥸
     *  ĴƱ
     *  ǡĹ8ӥåȡѥƥʤ1ȥåץӥåȡ
     *  ȥʬʤ
     */
    sil_wrb_mem(p_siopinib->scmd,
                (sil_reb_mem(p_siopinib->scmd) & 
                 ~(SCI_MD_SMS | SCI_MD_SDLS | SCI_MD_PE | SCI_MD_TSTLS | SCI_MD_SCSS_MASK)));
    sil_wrb_mem(p_siopinib->scmd,
                (sil_reb_mem(p_siopinib->scmd) | SCI_MD_SCSS_DIV0));

    /*
     *  ӥåȥ졼Ȥꡧ38400
     */
    sil_wrb_mem(p_siopinib->scbr, CONVERT_BITRATE(38400));

    sil_dly_nse(40000);

    /*
     *  ߤζػ
     */
    sil_wrb_mem(p_siopinib->sccr,
                (sil_reb_mem(p_siopinib->sccr) & ~(SCI_CR_TIE)));
    sil_wrb_mem(p_siopinib->sccr,
                (sil_reb_mem(p_siopinib->sccr) & ~(SCI_CR_TEIE | SCI_CR_RIE)));

    /*
     *  ݡ쥸ʽϡ
     */
    sil_wrb_mem((void *)PIO_PPR, PIO_PPR_UNPROTECT); /* ץƥȤβ */

    /* 
     *  Ϥػߤ塤
     *  ݡȵǽSCIǽϤꤷƱ˽ϵ
     *  ̡ꤹ뤳ȤϤǤʤ
     */
    sil_wrh_mem(p_siopinib->txdiocr, (~(PIO_CR_OUTE) & PIO_CR_PSEL_IO));
    sil_wrh_mem(p_siopinib->txdiocr, 
                (sil_reb_mem(p_siopinib->txdiocr) | (PIO_CR_OUTE | PIO_CR_PSEL_SCI)));

    sil_wrb_mem((void *)PIO_PPR, 0); /* ץƥ */

    /*
     *  RXDüҤhighǤ뤳Ȥå
     */
    assert((sil_reh_mem(p_siopinib->rxdioin) & (1 << p_siopinib->rxpio)) != 0);

    /*
     *  
     */
    sil_wrb_mem(p_siopinib->sccr,
                (sil_reb_mem(p_siopinib->sccr) | (SCI_CR_TE | SCI_CR_RE)));

}

Inline void
enable_int_send(const SIOPINIB *p_siopinib)
{
    sil_wrb_mem(p_siopinib->sccr,
                (sil_reb_mem(p_siopinib->sccr) | (SCI_CR_TEIE)));
}

Inline void
enable_int_receive(const SIOPINIB *p_siopinib)
{
    sil_wrb_mem(p_siopinib->sccr,
                (sil_reb_mem(p_siopinib->sccr) | (SCI_CR_RIE)));
}

Inline void
disable_int_send(const SIOPINIB *p_siopinib)
{
    sil_wrb_mem(p_siopinib->sccr,
                (sil_reb_mem(p_siopinib->sccr) & ~(SCI_CR_TEIE)));
}

Inline void
disable_int_receive(const SIOPINIB *p_siopinib)
{
    sil_wrb_mem(p_siopinib->sccr,
                (sil_reb_mem(p_siopinib->sccr) & ~(SCI_CR_RIE)));
}

Inline bool_t
sio_ready_send_char(const SIOPINIB *p_siopinib)
{
    if((sil_reb_mem(p_siopinib->scsr) & SCI_SR_TBEF) != 0){
        return true;
    } else {
        return false;
    }
}

Inline bool_t
sio_ready_receive_char(const SIOPINIB *p_siopinib)
{
    if((sil_reb_mem(p_siopinib->scsr) & SCI_SR_RBFF) != 0){
        return true;
    } else {
        return false;
    }
}

/*
 *	ꥢI/OݡȤΥץ
 */
SIOPCB *
sio_opn_por(ID siopid, intptr_t exinf)
{
	SIOPCB *p_siopcb = &(siopcb_table[siopid - 1]);
	const SIOPINIB *p_siopinib = p_siopcb->p_siopinib;

    /*
     *  ĥ¸
     *  ϡХå롼ϤȤʤ
     */
    p_siopcb->exinf = exinf;

    /*
	 *	ꥢI/Oߤޥ롥
	 */
	dis_int(p_siopinib->intno_rx);
	dis_int(p_siopinib->intno_tx);

    if(!(p_siopcb->initialized_flag)){
        p_siopcb->initialized_flag = true;

        sio_hardware_initialize(p_siopinib);
    }

    /*
	 *	ꥢI/OߤĤ롥
	 */
	ena_int(p_siopinib->intno_rx);
	ena_int(p_siopinib->intno_tx);

	return(p_siopcb);
}

/*
 *	ꥢI/OݡȤΥ
 */
void
sio_cls_por(SIOPCB *p_siopcb)
{
    const SIOPINIB *p_siopinib = p_siopcb->p_siopinib;

    /*
     *  ػ
     */
    sil_wrb_mem(p_siopinib->sccr,
                (sil_reb_mem(p_siopinib->sccr) & ~(SCI_CR_TE | SCI_CR_RE)));

    /*
     *  ߤػ
     */
    sil_wrb_mem(p_siopinib->sccr,
                (sil_reb_mem(p_siopinib->sccr) & ~(SCI_CR_TIE | SCI_CR_RIE)));

	/*
	 *	ꥢI/Oߤޥ롥
	 */
	dis_int(p_siopinib->intno_rx);
	dis_int(p_siopinib->intno_tx);
}

/*
 *	SIOγߥϥɥ
 */
void
sio_tx_isr(intptr_t exinf)
{
    /*
     *  exinfˤϡߤȯֹͥ椬äƤΤǡ
     *  顤ץ¸ĥ
     *  Хå롼ΰȤ
     */
    exinf = (siopcb_table[exinf - 1]).exinf;

	sio_irdy_snd(exinf);
}


/*
 *	SIOγߥϥɥ
 */
void
sio_rx_isr(intptr_t exinf)
{
    /*
     *  åȥꥬγװ򥯥ꥢ
     */
    x_clear_int(siopinib_table[exinf - 1].intno_rx);
    /*
     *  exinfˤϡߤȯֹͥ椬äƤΤǡ
     *  顤ץ¸ĥ
     *  Хå롼ΰȤ
     */
    exinf = (siopcb_table[exinf - 1]).exinf;

	sio_irdy_rcv(exinf);
}

/*
 *	ꥢI/OݡȤؤʸ
 */
bool_t
sio_snd_chr(SIOPCB *p_siopcb, char c)
{
    const SIOPINIB *p_siopinib = p_siopcb->p_siopinib;

    if(sio_ready_send_char(p_siopinib)){
        sil_wrb_mem(p_siopinib->sctb, (uint8_t)c);

        return true;
    } else {
        return false;
    }
}

/*
 *	ꥢI/OݡȤʸ
 */
int_t
sio_rcv_chr(SIOPCB *p_siopcb)
{
    const SIOPINIB *p_siopinib = p_siopcb->p_siopinib;

    if(sio_ready_receive_char(p_siopinib)){
        return (int_t)sil_reb_mem(p_siopinib->scrb);
    }

    return 0;
}

/*
 *	ꥢI/OݡȤΥХåε
 */
void
sio_ena_cbr(SIOPCB *p_siopcb, uint_t cbrtn)
{
    const SIOPINIB *p_siopinib = p_siopcb->p_siopinib;

    switch(cbrtn){
        case SIO_RDY_RCV:
            /*
             *	ߤΥޥ
             */
            enable_int_receive(p_siopinib);
            break;
        case SIO_RDY_SND:
            /*
             *	ߤΥޥ
             */
            enable_int_send(p_siopinib);
            break;
        default:
            break;
    }
}

/*
 *	ꥢI/OݡȤΥХåζػ
 */
void
sio_dis_cbr(SIOPCB *p_siopcb, uint_t cbrtn)
{
    const SIOPINIB *p_siopinib = p_siopcb->p_siopinib;

    switch(cbrtn){
        case SIO_RDY_RCV:
            /*
             *	ߤޥ
             */
            disable_int_receive(p_siopinib);
            break;
        case SIO_RDY_SND:
            /*
             *	ߤޥ
             */
            disable_int_send(p_siopinib);
            break;
        default:
            break;
    }
}

