/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 *	
 *	Copyright (C) 2011 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *	
 */

/*
 *	ꥢI/OǥХSIO˥ɥ饤СSH2A-MG-EVBѡ
 */

#ifndef TOPPERS_TARGET_SERIAL_H
#define TOPPERS_TARGET_SERIAL_H

/*
 *  ꥢI/OݡȽ֥å
 *  쥸Ϥȳֹ
 */
typedef struct sio_port_initialization_block {
    void *sccr;     /* 쥸 */
    void *scmd;     /* ⡼ɥ쥸 */
    void *scemd;    /* ĥ⡼ɥ쥸 */
    void *scbr;     /* ӥåȥ졼ȥ쥸 */
    void *sctb;     /* Хåե쥸 */
    void *scrb;     /* Хåե쥸 */
    void *scsr;     /* ơ쥸 */
    void *rxdiocr;  /* RXDüҤΥݡ쥸 */
    void *txdiocr;  /* TXDüҤΥݡ쥸 */
    void *sckiocr;  /* SCKüҤΥݡ쥸 */
    void *rxdioin;  /* RXDüҤΥݡϥ쥸 */
    uint8_t rxpio;  /* RXDбPIOֹ桧A/Bθο */
    INTNO intno_rx; /* Хåեեγֹ */
    INTNO intno_tx; /* Хåեץƥγֹ */
} SIOPINIB;

/*
 *  ꥢI/Oݡȴ֥å
 */
typedef struct sio_port_control_block{
    const SIOPINIB *p_siopinib; /* ꥢI/OݡȽ֥å */
    intptr_t exinf;             /* ĥ󡤤ʤå¸Υꥢݡȴ֥åSPCBˤؤΥݥ */
    bool_t initialized_flag;    /* ϡɥν򤷤 */
}
SIOPCB;

#define TNUM_SCI_PORT 4 /* SCIΥͥ */

/*
 *  쥸Ϣ
 */

/*
 *  ƥͥΥ١ɥ쥹
 */
#define SCI0_BASE 0xff610000
#define SCI1_BASE 0xff610010
#define SCI2_BASE 0xff610020
#define SCI3_BASE 0xff610030

/*
 *  ƥ쥸ΥեåȤ
 */
#define OFFSET_SCI_CR 0x00000002 /* 쥸 */
#define SCI_CR_TIE  0x80 /* Хåեץƥߵĥӥå */
#define SCI_CR_RIE  0x40 /* Хåեեߵĥӥå */
#define SCI_CR_TE   0x20 /* ĥӥå */
#define SCI_CR_RE   0x10 /* ĥӥå */
#define SCI_CR_TEIE 0x04 /* λߵĥӥå */
#define SCI_CR_CKS  0x00 /* åӥåȡ¢ܡ졼ȥͥ졼ѤǡSCKüҤPIO */
#define SCI_CR_CKS_MASK  0x03 /* åӥåȤΥޥ */

#define OFFSET_SCI_MD 0x00000000 /* ⡼ɥ쥸 */
#define SCI_MD_SMS   0x80 /* åƱΥӥåȤ0ǤϡĴƱ */
#define SCI_MD_SDLS  0x40 /* ǡĹ7ӥåȡΥӥåȤ0Ǥϡ8ӥå */
#define SCI_MD_PE    0x20 /* ѥƥꡧΥӥåȤ0Ǥϡѥƥʤ */
#define SCI_MD_OES   0x10 /* ѥƥΥӥåȤ0Ǥϡѥƥ */
#define SCI_MD_TSTLS 0x08 /* 2ȥåץӥåȡΥӥåȤ0Ǥϡ1ȥåץӥå */
#define SCI_MD_SCSS_DIV0  0x00 /* ȥӥåȡյǽåAʬʤ */
#define SCI_MD_SCSS_DIV4  0x01 /* ȥӥåȡյǽåA4ʬ */
#define SCI_MD_SCSS_DIV16 0x02 /* ȥӥåȡյǽåA16ʬ */
#define SCI_MD_SCSS_DIV64 0x03 /* ȥӥåȡյǽåA64ʬ */
#define SCI_MD_SCSS_MASK 0x03 /* ȥӥåȤΥޥ */

#define OFFSET_SCI_EMD 0x00000008 /* ĥ⡼ɥ쥸 */
#define SCI_EMD_SDIR  0x08 /* MSBեȡΥӥåȤ0ǤϡLSBե */
#define SCI_EMD_CKPOS 0x02 /* ȿž롧ΥӥåȤ0Ǥϡʤ */
#define SCI_EMD_CKPHS 0x01 /* Ⱦ٤餻롧ΥӥåȤ0Ǥϡ٤餻ʤ */

#define OFFSET_SCI_BR 0x00000001 /* ӥåȥ졼ȥ쥸 */
#define OFFSET_SCI_TB 0x00000003 /* Хåե쥸 */
#define OFFSET_SCI_RB 0x00000005 /* Хåե쥸 */

#define OFFSET_SCI_SR 0x00000004 /* ơ쥸 */
#define SCI_SR_TBEF  0x80 /* Хåեץƥե饰 */
#define SCI_SR_RBFF  0x40 /* Хåեեե饰 */
#define SCI_SR_OREF  0x20 /* Х󥨥顼ե饰 */
#define SCI_SR_FREF  0x10 /* ե졼ߥ󥰥顼ե饰 */
#define SCI_SR_PERF  0x08 /* ѥƥ顼ե饰 */
#define SCI_SR_TSEF  0x04 /* եȥ쥸ץƥե饰 */

/*
 *  Хå롼μֹ
 */
#define SIO_RDY_SND    1U        /* ǽХå */
#define SIO_RDY_RCV    2U        /* ΥХå */

/*
 *	SIOγߥϥɥΥ٥ֹ
 */
#define INTNO_SCI0_RXE 312 /* SCI0顼 */
#define INTNO_SCI0_RXF 313 /* SCI0Хåեե */
#define INTNO_SCI0_TXE 314 /* SCI0Хåեץƥ */
#define INTNO_SCI0_TXC 315 /* SCI0λ */
#define INTNO_SCI1_RXE 316 /* SCI1顼 */
#define INTNO_SCI1_RXF 317 /* SCI1Хåեե */
#define INTNO_SCI1_TXE 318 /* SCI1Хåեץƥ */
#define INTNO_SCI1_TXC 319 /* SCI1λ */
#define INTNO_SCI2_RXE 320 /* SCI2顼 */
#define INTNO_SCI2_RXF 321 /* SCI2Хåեե */
#define INTNO_SCI2_TXE 322 /* SCI2Хåեץƥ */
#define INTNO_SCI2_TXC 323 /* SCI2λ */
#define INTNO_SCI3_RXE 324 /* SCI3顼 */
#define INTNO_SCI3_RXF 325 /* SCI3Хåեե */
#define INTNO_SCI3_TXE 326 /* SCI3Хåեץƥ */
#define INTNO_SCI3_TXC 327 /* SCI3λ */

/*
 *  ǥեȤǻѤ륷ꥢݡȤϥͥ0
 *  ХåƤ֤γװϡλߤǤ뤬
 *  ϡλߤ٥ȥꥬǤꡤХåեץƥ
 *  ߤåȥꥬǤ뤳Ȥ˵롥
 *  åȥꥬξ硤˼ԤƤߤĤޤǤδ֤
 *  ХåեˤʤäƤޤȡߤĤƤ⡤ʹߤ
 *  ߤȯʹߤԤʤʤ뤳Ȥꤦ롥
 */
#define INHNO_SIO_TX	 INTNO_SCI0_TXC /* ߥϥɥֹ */
#define INTNO_SIO_TX	 INTNO_SCI0_TXC /* ֹ */
#define INHNO_SIO_RX	 INTNO_SCI0_RXF /* ߥϥɥֹ */
#define INTNO_SIO_RX	 INTNO_SCI0_RXF /* ֹ */
#define INTPRI_SIO		 (-4)			  /* ͥ */
#define INTATR_SIO		 0U 			  /* ° */

/*
 *  PIOϢΥ쥸
 */
#define PIO_PPR 0xff464030 /* ݡȥץƥȥ쥸 */
#define PIO_PPR_UNPROTECT 0xf1 /* ץƥȲͰʳ񤭹ȡץƥ */

#define PIO_PA00CR 0xff464040 /* ݡA00쥸 */
#define PIO_PA01CR 0xff464042 /* ݡA01쥸 */
#define PIO_PA02CR 0xff464044 /* ݡA02쥸 */
#define PIO_PA03CR 0xff464046 /* ݡA03쥸 */
#define PIO_PA04CR 0xff464048 /* ݡA04쥸 */
#define PIO_PA05CR 0xff46404A /* ݡA05쥸 */
#define PIO_PA06CR 0xff46404C /* ݡA06쥸 */
#define PIO_PA07CR 0xff46404E /* ݡA07쥸 */
#define PIO_PA08CR 0xff464050 /* ݡA08쥸 */
#define PIO_PA09CR 0xff464052 /* ݡA09쥸 */
#define PIO_PA10CR 0xff464054 /* ݡA10쥸 */
#define PIO_PA11CR 0xff464056 /* ݡA11쥸 */
#define PIO_PA12CR 0xff464058 /* ݡA12쥸 */
#define PIO_PA13CR 0xff46405A /* ݡA13쥸 */
#define PIO_PA14CR 0xff46405C /* ݡA14쥸 */
#define PIO_PA15CR 0xff46405E /* ݡA15쥸 */

#define PIO_PB00CR 0xff464080 /* ݡB00쥸 */
#define PIO_PB01CR 0xff464082 /* ݡB01쥸 */
#define PIO_PB02CR 0xff464084 /* ݡB02쥸 */
#define PIO_PB03CR 0xff464086 /* ݡB03쥸 */
#define PIO_PB04CR 0xff464088 /* ݡB04쥸 */
#define PIO_PB05CR 0xff46408A /* ݡB05쥸 */
#define PIO_PB06CR 0xff46408C /* ݡB06쥸 */
#define PIO_PB07CR 0xff46408E /* ݡB07쥸 */
#define PIO_PB08CR 0xff464090 /* ݡB08쥸 */
#define PIO_PB09CR 0xff464092 /* ݡB09쥸 */

#define PIO_CR_INE  0x8000 /* ϵĥե饰 */
#define PIO_CR_OUTE 0x0010 /* ϵĥե饰 */
#define PIO_CR_PSEL_IO  0x0000 /* ݡȵǽPIO or յǽ */
#define PIO_CR_PSEL_SCI 0x0003 /* ݡȵǽSCI */
#define PIO_CR_PSEL_MASK 0x000f /* ݡȵǽΥޥ */

#define PIO_PAIN 0xff464062 /* ݡAϥ쥸 */
#define PIO_PBIN 0xff4640A2 /* ݡBϥ쥸 */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ӥåȥ졼Ȥ顤BRꤹͤ׻ޥ
 *  f(PBA) / (64 * 2^(2m-1) * br) - 1m = MD_SCSS
 */
#define CONVERT_BITRATE(br) (uint8_t)(((40000000 * 2) / (64 * 1 * br)) - 1)

extern SIOPCB siopcb_table[TNUM_SCI_PORT];
extern const SIOPINIB siopinib_table[TNUM_SCI_PORT];

/*
 *	SIOɥ饤Фν
 */
extern void sio_initialize(intptr_t exinf);
extern void sio_hardware_initialize(const SIOPINIB *p_siopinib);

/*
 *	ꥢI/OݡȤΥץ
 */
extern SIOPCB *sio_opn_por(ID siopid, intptr_t exinf);

/*
 *	ꥢI/OݡȤΥ
 */
extern void sio_cls_por(SIOPCB *p_siopcb);

/*
 *	SIOγߥϥɥ
 */
extern void sio_tx_isr(intptr_t exinf);
extern void sio_rx_isr(intptr_t exinf);

/*
 *	ꥢI/OݡȤؤʸ
 */
extern bool_t sio_snd_chr(SIOPCB *siopcb, char c);

/*
 *	ꥢI/OݡȤʸ
 */
extern int_t sio_rcv_chr(SIOPCB *siopcb);

/*
 *	ꥢI/OݡȤΥХåε
 */
extern void sio_ena_cbr(SIOPCB *siopcb, uint_t cbrtn);

/*
 *	ꥢI/OݡȤΥХåζػ
 */
extern void sio_dis_cbr(SIOPCB *siopcb, uint_t cbrtn);

/*
 *	ꥢI/OݡȤǽХå
 */
extern void sio_irdy_snd(intptr_t exinf);

/*
 *	ꥢI/OݡȤμΥХå
 */
extern void sio_irdy_rcv(intptr_t exinf);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_TARGET_SERIAL_H */
