/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 *	
 *	Copyright (C) 2011-2012 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *	
 */

/*
 *	åȰ¸⥸塼 ֥SH72AW
 */

#define  TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#define CAST(type, val) (val)		 /* 㥹ȤԤޥ */

/*
 *	֥ѤΥޥͭˤ
 */
#define TOPPERS_ASM_MACRO
#include "kernel_impl.h"
#include "offset.h"


/*
 *	٥ΥåȰ¸ν
 *
 *	ȥåץ⥸塼ǡν˸ƤӽФ롥
 */

/*
 *	ROMˡDATAΥ0ȡBSSTXTľ֤
 *	뤿ᡤDATAΥ0ˤʤΥߡѿ
 *	ѥκŬˤΤɤᡢ֥ǵҤ
 *	Ƥ롣
 */
	.data
_dummy:
	.byte	0x00

	.text
	.align 2
	.global _hardware_init_hook
_hardware_init_hook:
    /*
     *  ץƥȤ
     */
    mov.l    _spr0, r0
    mov     #SPR0_CANCEL_PROTECT, r1
    mov.b   r1, @r0

    /*
     *  ᥤ󥯥åȯ߸гߤ
     */
    mov.l    _mcmcr, r0
    mov     #MCMCR_LXIE, r1
    mov.b   r1, @r0

    /*
     *  FPU
     */
    mov.l    _mstpcr, r0
    mov.w   _mstpcr_fpustp, r1
    mov.w   r1, @r0

    /*
     *  ƥ९åʬʤ
     */
    mov.l    _scdr, r0
    mov     #SCDR_SYSD_DIV0, r1
    mov.b   r1, @r0

    /*
     *  Хåʬ2ʬ
     */
    mov.l    _bcdr, r0
    mov     #BCDR_BUSD_DIV2, r1
    mov.b   r1, @r0

    /*
     *  յǽå
     *  åA4ʬ
     *  åB2ʬ
     */
    mov.l    _pbcdr, r0
    mov.l   _pbcdr_pbad_div4, r1
    mov.l   _pbcdr_pbbd_div2, r2
    or      r2, r1
    mov.l   r1, @r0

    /*
     *  ƥ९åŪ˥ᥤ󥯥å
     */
    mov.l    _scsr, r0
    mov     #SCSR_SCS_XIN, r1
    mov.b   r1, @r0

    /*
     *  PLLåȿ160MHz
     *  ϰޤǤ1msec
     */
    mov.l    _plcr, r0
    mov.l   @r0, r0
    mov.w   _plcr_vcod, r1
    not     r1, r1
    mov.w   r1, @r0

    /*
     *  1msecԤ
     *  Ǥϡ20MHzΥåCPUưƤϤʤΤǡ
     *  20M * 1m = 20000 nopƤ٤Ф褤Ϥ
     */
    mov.w   _wait_pll_ready_count, r0
_wait_pll_ready:
    nop
    dt      r0          /* r0 - 1 -> r0; r0 == 0 ? */
    bf      _wait_pll_ready /* if r0 != 0 then jump to _wait_pll_ready */
    nop     /* ٱʬå */

    /*
     *  ƥ९åPLL
     */
    mov.l    _scsr, r0
    mov     #SCSR_SCS_PLL, r1
    mov.b   r1, @r0

    /*
     *  ץƥ
     */
    mov.l    _spr0, r0
    mov     #SPR0_PROTECT, r1
    mov.b   r1, @r0

    /*
     *  start
     */
    rts
    nop

/*
 *  åϢΥ쥸
 *  hardware_init_hookǻѤǡ᤯֤
 */
 /*
  *  long data
  */
 .align 4
_spr0:
    .long SPR0 /* ƥץƥȥ쥸 */
_mcmcr:
    .long MCMCR /* ᥤ󥯥åƻ뵡ǽ쥸 */
_plcr:
    .long PLCR /* PLL쥸 */
_scsr:
    .long SCSR /* ƥ९å쥸 */
_scdr:
    .long SCDR /* ƥ९åʬ쥸 */
_bcdr:
    .long BCDR /* Хå */
_pbcdr:
    .long PBCDR /* յǽåʬ쥸 */
_rdccr:
    .long RDCCR /* RDCå쥸f(PBA)ʬ */
_cocr:
    .long COCR /* åϵǽ쥸f(BUS)ʬ */
_mstpcr:
    .long MSTPCR /* ⥸塼륹ȥå쥸 */
_pbcdr_pbad_div2:
    .long PBCDR_PBAD_DIV2 /* åA2ʬ */
_pbcdr_pbad_div4:
    .long PBCDR_PBAD_DIV4 /* åA4ʬ */
_pbcdr_pbbd_div0:
    .long PBCDR_PBBD_DIV0 /* åBʬʤ */
_pbcdr_pbbd_div2:
    .long PBCDR_PBBD_DIV2 /* åB2ʬ */
/*
 *  word data
 */
_plcr_vcod:
    .word PLCR_VCOD /* PLLνϡ120MHzʤΥӥåȤ0ˤȡ160MHz*/
_mstpcr_fpustp:
    .word MSTPCR_FPUSTP /* FPUߡʺƤư뤿ˤϥꥻåȤ*/
_wait_pll_ready_count:
    .word 0x4e20

    /*
     *  ĥӥν
     *  14ѥ᡼R4R7
     *  5ѥ᡼R2  ƥॹåΰֲѤ
     *  ǽɡR1
     *  p_runtskR8
     *  ƤӽФꤹ뤿ΥӥåȥޥåסR9
     *    0x01: excnest_count == 0 && rundom != TACP_KERNEL
     *    0x02: excnest_count == 0
     *  SVCIMASKR10
     *  åpr, r8r9r10
     *  MPU̵
     *  ø⡼ɼ¹ or 󥿥ƥ
     *    priv_mode == 1 or nestcount > 0
     *  ƥॹå or 󥿥ƥѥå
     *  ǽɤβ¥åϼ¹ԺѤ
     */
    .section .text_kernel
    .global _extsvc_entry
    .extern	__kernel_tmax_fncd
    .extern	__kernel_extsvc_table
    .extern __kernel_call_texrtn_stask

#define SIZEOF_SVCINIB 8
#define SVCINIB_svcrtn 0
#define SVCINIB_stksz  4

    .align 4
extsvc_error_RSFN:
	mov.l	_e_rsfn_svc, r0     /* 顼ɤ֤ */
	mov.l   r0, @-r15       /* ֤ͤ򥹥å¸ */
    bra     svc_entry_r
    nop

extsvc_error_NOMEM:
	mov.l   _e_nomem_svc, r0    /* 顼ɤ֤ */
    add     #(4*2), r15         /* åΤƤ */
	mov.l   r0, @-r15       /* ֤ͤ򥹥å¸ */
    bra     svc_entry_r
    nop
extsvc_error_SYS:
	mov.l   _e_sys_svc, r0      /* 顼ɤ֤ */
    add     #(4*2), r15         /* åΤƤ */
	mov.l   r0, @-r15       /* ֤ͤ򥹥å¸ */
    bra     svc_entry_r
    nop

_extsvc_entry:
extsvc_entry_1:
    /*
     *  ǽɤΥå
     */
    mov.l   _tmax_fncd_extsvc, r0
    mov.l   @r0, r0
    cmp/gt  r0, r1                  /* ǽɤξ¥å(tmax_fncd < r1) */
    bt      extsvc_error_RSFN       /* ¤򥪡ФƤʤХ顼 */

    /*
     *  ĥӥΥơ֥
     *  R3 = &svcinib
     */
    mov.l   _svcinib_table_extsvc, r3
    mov     #SIZEOF_SVCINIB, r0
    add     #-1, r1                     /* ǽ -= 1 */
    mulr    r0, r1                      /* R1 = ǽ * sizeof(SVCINIB) */
    add     r1, r3                      /* R3 += R1(ơ֥ƬϤоǤؤΥեåȤä) */

    /*
     *  ĥӥΤΥɥ쥹NULLǤʤ
     */
    mov.l   @(SVCINIB_svcrtn,r3), r0    /* R0 = svcinib->svcrtn */
    cmp/eq  #0, r0                      /* R0 == NULL? */
    bt      extsvc_error_RSFN           /* NULLʤХ顼 */
    mov     r0, r1                      /* R1 = svcinib->svcrtn */

    add     #-4, r15                /* domidѤΰ */
	mov.l   r2, @-r15               /* 5򥹥åѤ */
    /*
     *  ƤӽФ󥿥ƥȤ
     */
    mov     #0x02, r0
    tst     r0, r9          /* excnest_count != 0 */
	bt      extsvc_entry_3	/* 󥿥ƥȤʤХå */

extsvc_entry_2:
    /*
     *  åλ̤å
     */
    mov.l   @(SVCINIB_stksz,r3), r0     /* R0 = svcinib->stksz */
    mov     r15, r3                     /* R3 = ssp */
    cmp/hi  r3, r0                      /* r3 < r0 ʤ */
    bt      extsvc_error_NOMEM          /* 顼 */
    sub     r0, r3                      /* ssp -= svcinib->stkszR3 = Ǿssp */
    mov.l   @(TCB_p_tinib,r8), r2
    mov.l   @(TINIB_sstk_bottom,r2), r0 /* R0 = åνλ */
    cmp/hi  r0, r3                      /* r0 < r3 ʤ */
    bt      extsvc_error_NOMEM          /* 顼 */
    sub     r3, r0                      /* R0 = åνλ - Ǿsspå줫εΥ */
    mov.l   @(TINIB_sstksz,r2), r3      /* R3 = å */
    cmp/hi  r3, r0                      /* r0 > r3 ʤ */
    bt      extsvc_error_NOMEM          /* 顼 */

    /*
     *  svclevel򥤥󥯥
     */
    mov.b   @(TCB_svclevel,r8), r0  /* svclevelɤ߹ */
    mov     #255, r3
    cmp/hs  r3, r0                  /* svclevelξ¥å(r3 <= r0:unsigned) */
	bt      extsvc_error_SYS        /* ͥȤξ¤ä票顼 */
	add     #1, r0                  /* svclevel += 1 */
    mov.b   r0, @(TCB_svclevel,r8)  /* svclevel򹹿 */


    /*
     *  ¹ԥɥᥤ򥫡ͥɥᥤ
     */
    mov     #0x01, r0
    tst     r0, r9          /* rundom != TACP_KERNEL  */
	bt      extsvc_entry_3	/* ͥɥᥤʤХå */
    mov.l   _rundom_svc, r3     /* R3 = &rundom */
    mov     #0, r0
	mov.l	r0, @r3             /* rundom = TACP_KERNEL */

    /*
     *  domid
     */
    mov.l   @(TINIB_p_dominib,r2), r0   /* R0 = p_dominib */
    mov.l   _dominib_table_extsvc, r3   /* R3 = dominib_table */
    sub     r3, r0                      /* R0 = &dominib_table[x] - &dominib_table[0] */
    /*
     *  dominibΥ40byte
     */
    /*
     *  R0 = 40x / 8 => 5x
     *  3bitե
     */
    shar    r0
    shar    r0
    shar    r0
    /*
     *  5x / 5 => x
     */
    mov.l   _33333333_extsvc, r3    /* R3 = 0x33333333 */
    mulr    r0, r3                  /* R3 = 5x * 0x33333333 = 0xffffffff * x = -x */
    neg     r3, r0
    add     #TMIN_DOMID, r0

    bra     extsvc_entry_4
    nop

extsvc_entry_3:
	mov     #TDOM_KERNEL, r0    /* ƤӽФTDOM_KERNEL */
extsvc_entry_4:
	mov.l   r0, @(4, r15)       /* ƤӽФdomid򥹥åѤ */

    /*
     *  ipm
     */
    stc     sr, r2
    mov     #0xf0, r0
    not     r0, r0
    and     r0, r2      /* imask򥯥ꥢ */
    or      r10, r2     /* imask */
    ldc     r2, sr

    /*
     *  ĥӥΤƤ
     */
	jsr     @r1                     /* ӥ롼Ƥ */
    nop
	mov.l   @r15+, r2               /* 5򥹥å */
	mov.l   @r15+, r2               /* ƤӽФdomid򥹥å */

extsvc_entry_r:
    /*
     *  ֥롼󥳡Ǥˤ뤿ᡤ
     *  åSR񤭴ʤɤνɬפʤ
     */
	mov.l   r0, @-r15       /* ֤ͤ򥹥å¸ */

    /*
     *  SR˥åȤƤipmr10¸
     *  - chg_ipmloc_cpuIMASK򹹿ؤб
     *  ߶ػ  
     */
    stc     sr, r0
    and     #0xf0, r0   /* IMASKΤߤĤ */
    mov     r0, r10     /* IMASK¸ */
    stc     sr, r0
    or      #0xf0, r0   /* IMASK򥻥å */
    ldc     r0, sr

    /*
     *  ƤӽФ󥿥ƥȤ
     */
    mov     #0x02, r0
    tst     r0, r9      /* excnest_count != 0 */
	bt      extsvc_prv_r   /* 󥿥ƥȤʤХ꥿ */

    /*
     *  svclevelǥ
     */
    mov.b   @(TCB_svclevel,r8), r0  /* svclevelɤ߹ */
    dt      r0                      /* svclevel -= 1 && svclevel0 */
    mov.b   r0, @(TCB_svclevel,r8)  /* svclevel򹹿 */
    bf      extsvc_prv_r               /* 0ǤʤХ꥿ */
    
    /*
     *  ¹ԥɥᥤ°ɥᥤ᤹
     */
   	mov.l	@(TCB_p_tinib,r8), r0       /* ֥åɤ߽Ф */
	mov.l	@(TINIB_p_dominib,r0), r0   /* ɥᥤ֥åɤ߽Ф */
	mov.l	@(DOMINIB_domptn,r0), r0    /* °ɥᥤμ */
    mov.l   _rundom_svc, r1             /* R1 = &rundom */
    mov.l   r0, @r1                     /* rundom = °ɥᥤ */
    /*
     *  ӥ¹˳ĥӥ뤳ȤϤʤᡢ
     *  ꥿褬󥿥ƥȤǤʤʤС꥿
     *  㳰α֤ǤϤʤ
     */

    /*
     *  Ԥػ߾֤
     */
    mov     #TCB_waifbd_mask, r0
    not     r0, r0
    mov.b   @(TCB_waifbd,r8), r1
    and     r1, r0
    mov.b   r0, @(TCB_waifbd,r8)

    /*
	 *  㳰¹Ծ郎äƤ뤫å
	 */
	mov.l	@(TCB_texptn,r8), r0    /* α㳰װɽФ */
    cmp/eq  #0, r0                  /* α㳰װ0 */
	bt      extsvc_r                /* 0ʤ꥿ */
	mov.b	@(TCB_enatex,r8), r0    /* 㳰ľ֤ɽФ */
    and     #TCB_enatex_mask, r0
    cmp/eq  #0, r0                  /* 㳰ػ߾֤ */
	bt      extsvc_r                /* ػߤʤ꥿ */

	/*
     *  ߥޥ֤ 
     */
    mov.l   _ipmflg_svc, r0
    mov.l   @r0, r0
    cmp/eq  #0, r0
    bt      extsvc_r

	/*
     *  ӥ뤫Υ꥿Υƥ֤CPUå֤
     */
    mov.l   _lock_flag_svc, r0
    mov.l   @r0, r0
    cmp/eq  #0, r0
    bf      extsvc_r             /* CPUå֤ǤʤХ꥿ */
    nop

    /*
     *  褬桼ɥᥤ󤫥å
     */
    mov     #0x01, r0
    tst     r0, r9          /* ƤӽФΥɥᥤ == TACP_KERNEL */
	bf      extsvc_usr_r_texrtn
    nop
extsvc_prv_r_texrtn:
    /*
     *  CPUå
     */
    mov.l   _lock_flag_svc, r0
    mov     #1, r1
    mov.l   r1, @r0

    mov.l   _saved_iipm_svc, r0
    mov     #IIPM_ENAALL, r1
    mov.l   r1, @r0

    /*
     *  SRIMASKIIPM_LOCK  
     *  ˤϳͥ٥ޥ֤뤿ᡤ
     *  IMASK0ΤϤʤΤǡꥢʤ
     */
    mov.l   _iipm_lock_svc, r0
    stc     sr, r1
    or      r0, r1      /* imask=IIPM_LOCK */
    ldc     r1, sr

    mov.l   _call_texrtn_stask_extsvc, r0
    jsr     @r0  /* ƥॿѤΥ㳰 */
    nop

    /*
     *  SRIMASK߶ػ  
     */
    stc     sr, r1
    mov     #0xf0, r0
    or      r0, r1      /* imask=0xf0 */
    ldc     r1, sr

    /*
     *  ꥿CPUåȤʤ褦
     */
    mov.l   _lock_flag_svc, r0
    mov     #0, r1
    mov.l   r1, @r0
extsvc_prv_r:
    bra     svc_prv_r       /* TACP_KERNELξ */
    nop
extsvc_usr_r_texrtn:
    /*
     *  r0 = p_runtsk
     */
    mov     r8, r0
	bsr     _prepare_texrtn_utask    /* 桼ѤΥ㳰 */
    nop
    bra     svc_usr_r       /* TACP_KERNELǤʤ */
    nop

extsvc_r:
    /*
     *  褬桼ɥᥤ󤫥å
     */
    mov     #0x01, r0
    tst     r0, r9          /* ƤӽФΥɥᥤ == TACP_KERNEL */
    bt      svc_prv_r       /* TACP_KERNELξ */
    nop
    bra     svc_usr_r       /* TACP_KERNELǤʤ */
    nop

    .align 4
_tmax_fncd_extsvc:
    .long   _tmax_fncd
_svcinib_table_extsvc:
    .long   _svcinib_table
_e_nomem_svc:
    .long   E_NOMEM
_e_sys_svc:
    .long   E_SYS
_call_texrtn_stask_extsvc:
    .long   _call_texrtn_stask
_dominib_table_extsvc:
    .long _dominib_table
_33333333_extsvc:
    .long 0x33333333
_saved_iipm_svc:
    .long _saved_iipm

    /*
     *  ӥν
     *  14ѥ᡼R4R7
     *  5ѥ᡼R2  ƥॹåΰֲѤ
     *  ǽɡR1
     *  쥸λ
     *    p_runtskR8
     *    ƤӽФꤹ뤿ΥӥåȥޥåסR9
     *      0x01: excnest_count == 0 && rundom != TACP_KERNEL
     *      0x02: excnest_count == 0
     *    SVCIMASKR10
     *    åpr, r8r9r10
     */
    .section .text_shared
    .align 4
    .global __kernel_svc_entry
__kernel_svc_entry:
    sts.l   pr, @-r15   /* PR */
    mov.l   r8, @-r15   /* r8 */
    mov.l   r9, @-r15   /* r9 */
    mov.l   r10, @-r15  /* r10 */

    /*
     *  SR˥åȤƤipm¸
     *  ߶ػ
     */
    stc     sr, r0
    and     #0xf0, r0   /* IMASKΤ߻Ĥ */
    mov     r0, r10     /* IMASK¸ */
    stc     sr, r0
    or      #0xf0, r0   /* IMASK߶ػߤ˥å */
    ldc     r0, sr

    /* 
     *  MPU̵
     */
	mov.l	_mpcmpen_svc_0, r9
	mov.l	_mpuinvalid_svc, r0
	mov.l	r0, @r9
    mov.l   svc_entry_0_svc, r0
    jmp     @r0
    nop

    .align 4
svc_entry_0_svc:
    .long svc_entry_0
_mpuinvalid_svc:
	.long 0xaaaa0000
_mpcmpen_svc_0:
	.long MPCMPEN   /* MPUͭ */

    .section .text_kernel
	.extern	_svc_table
    .align 4
svc_entry_0:
    mov.l   __kernel_p_runtsk_svc, r8   /* ¹Υ */
    mov.l   @r8, r8   /* ¹Υ */
    /* 
     *  R9: ƤӽФꤹ뤿Υӥåȥޥå
     *    0x01: excnest_count == 0 && rundom != TACP_KERNEL
     *    0x02: excnest_count == 0
     */
    mov     #0, r9 /* 0 */

    /*
	 *  ƥȤθƤӽФå
	 */
    mov.l   _excnest_count_svc, r0
    mov.l   @r0, r0
	cmp/eq  #0,	r0                      /*  ¿ųߤǤʤ */
	bf      svc_entry_1                 /*  ¿ųߤʤХå */
    mov     #0x02, r0
    or      r0, r9          /* excnest_count == 0ΥӥåȤ򥻥å */

    /*
     *  桼ɥᥤ󤫤θƤӽФå
     *  ĥӥ¹ǤС
     *  ͥɥᥤ󤫤θƤӽФȤʤΤǡ
     *  svclevelΥåɬפʤ
     */
    mov.l   _rundom_svc, r0
    mov.l   @r0, r0
    cmp/eq  #0, r0          /* rundom == 0(TACP_KERNEL) */
    bt      svc_entry_1     /* 0ʤХå */
    mov     #0x01, r0
    or      r0, r9          /* rundom != TACP_KERNELΥӥåȤ򥻥å */

    /*
     *  ξ֤ø⡼ɼ¹˰ܹԤ
     *  ¹ԥɥᥤ󤬥ͥɥᥤǤꡤ
     *  褬ƥȤʤС¹ǤϤ
     *  ʤΤǡp_runtskNULLɤΥåɬפʤϤ
     */
    mov     #1, r0
    mov.b	r0,	@(TCB_priv_mode,r8)     /* ø⡼ɼ¹ */

    /*
     *  桼å¸
     *  ƥॹåؤڤؤ
     */
    mov.l   r15, @(TCB_usp,r8)              /* usp¸ */
    mov.l   @(TCB_ssp,r8), r15    /* sspν */

svc_entry_1:
    /*
     *  ǽɤΥå
     */
    mov.l   _tmin_fncd_svc, r0
	cmp/ge  r0, r1       	/* ǽɤβ¤Υå(TMIN_FNCD <= r1) */
	bf      svc_entry_7     /* ¤ⲼʤХ顼 */
    mov     #0, r0   
	cmp/gt  r0, r1 			/* ǽɤå(0 < r1) */
    bf      svc_entry_2     /* ӥξ */
    nop
	bra     _extsvc_entry   /* ĥӥξ */
    nop

svc_entry_2:
    /*
     *  ipm
     */
    stc     sr, r2
    mov     #0xf0, r0
    not     r0, r0
    and     r0, r2      /* imask򥯥ꥢ */
    or      r10, r2     /* imask */
    ldc     r2, sr

	mov.l   r2, @-r15       /* 5򥹥åѤ */

    /*
     *  ӥΥơ֥
     *  ӥΤƤ
     */
	neg     r1, r1          /* ȿž */
    shal    r1
    shal    r1              /* 2bitե(4:ɥ쥹Ĺ4byte) */
    mov.l   _svc_table_svc, r0
	mov.l   @(r0,r1), r1    /* ơ֥ */
	jsr     @r1             /* ӥ롼Ƥ */
	mov.l   @r15+, r2       /* 5򥹥å */

	mov.l   r0, @-r15       /* ֤ͤ򥹥å¸ */
    /*
     *  SR˥åȤƤipm¸
     *  - chg_ipmloc_cpuIMASK򹹿ؤб
     *  ߶ػ  
     */
    stc     sr, r0
    and     #0xf0, r0   /* IMASKΤߤĤ */
    mov     r0, r10     /* IMASK¸ */
    stc     sr, r0
    or      #0xf0, r0   /* IMASK򥻥å */
    ldc     r0, sr

svc_entry_r:
    /*
     *  ˤ߶ػ߾֤ǥפƤ
     */
    /*
     *  ֥롼󥳡Ǥˤ뤿ᡤ
     *  åSR񤭴ʤɤνɬפʤ
     */

    /*
     *  褬桼ɥᥤ󤫥å
     *  ĥӥ¹ǤС
     *  ϥͥɥᥤʤΤǡ
     *  svclevelΥåɬפʤ
     */
    mov     #0x01, r0
    tst     r0, r9          /* rundom == TACP_KERNEL */
    bt      svc_prv_r       /* TACP_KERNELʤХå */

    /*
	 *  褬ƥȤå
	 */
    mov     #0x02, r0
    tst     r0, r9          /* excnest_count != 0 */
    bt      svc_prv_r       /* 0ǤʤХå */

	/*
	 *  Ԥػߤ
	 */
    mov     #TCB_waifbd_mask, r0
    not     r0, r0
    mov.b   @(TCB_waifbd,r8), r1
    and     r1, r0
    mov.b   r0, @(TCB_waifbd,r8)
	
    /*
	 *  㳰¹Ծ郎äƤ뤫å
	 */
	mov.l	@(TCB_texptn,r8), r0    /* α㳰װɽФ */
    cmp/eq  #0, r0                  /* α㳰װ0 */
	bt      svc_usr_r               /* 0ʤ꥿ */
	mov.b	@(TCB_enatex,r8), r0    /* 㳰ľ֤ɽФ */
    and     #TCB_enatex_mask, r0
    cmp/eq  #0, r0                  /* 㳰ػ߾֤ */
	bt      svc_usr_r               /* ػߤʤ꥿ */

	/*
     *  ߥޥ֤ 
     */
    mov.l   _ipmflg_svc, r0
    mov.l   @r0, r0
    cmp/eq  #0, r0
    bt      svc_usr_r               /* ipmflg == falseʤ꥿ */

	/*
     *  ӥ뤫Υ꥿Υƥ֤CPUå֤
     */
    mov.l   _lock_flag_svc, r0
    mov.l   @r0, r0
    cmp/eq  #0, r0
    bf      svc_usr_r             /* CPUå֤ǤʤХ꥿ */
    nop

    /*
     *  㳰ƤӽФ郎·äƤС
     *  桼Υ㳰
     *  r0 = p_runtsk
     */
    mov     r8, r0
    bsr      _prepare_texrtn_utask
    nop

svc_usr_r:
    mov.l   @r15+, r0   /* ֤ͤ򥹥å */

    /*
     *  桼åؤڤؤ
     */
    mov.l   r15, @(TCB_ssp,r8)          /* ssp¸ */
    mov.l   @(TCB_usp,r8), r15          /* uspΥå */

    mov     #0, r1
	mov.b	r1,	@(TCB_priv_mode,r8)     /* ø⡼ɼ¹Ԥȴ */
    
    /* 
     *  MPUͭ
     */
	mov.l	_mpcmpen_svc, r1
	mov.l	_mpuvalid_svc, r2
    mov.l   svc_usr_r_1_svc, r3
    jmp     @r3
    nop

svc_prv_r:
    mov.l   @r15+, r0   /* ֤ͤ򥹥å */

    /*
     *  ipm
     */
    stc     sr, r1
    mov     #0xf0, r2
    not     r2, r2
    and     r2, r1      /* imask򥯥ꥢ */
    or      r10, r1     /* imask */
    ldc     r1, sr

    mov.l   @r15+, r10  /* r10 */
    mov.l   @r15+, r9   /* r9 */
    mov.l   @r15+, r8   /* r8 */
    lds.l   @r15+, pr   /* pr */
    rts
    nop

svc_entry_7:
	mov.l   _e_rsfn_svc, r0 /* 顼ɤ֤ͤ */ 
	mov.l   r0, @-r15       /* ֤ͤ򥹥å¸ */
	bra     svc_entry_r     /* ӥνи */
    nop

    .align 4
__kernel_p_runtsk_svc:
    .long __kernel_p_runtsk
_rundom_svc:
    .long _rundom
_svc_table_svc:
    .long _svc_table
_tmin_fncd_svc:
    .long TMIN_FNCD
_e_rsfn_svc:
    .long E_RSFN
_excnest_count_svc:
    .long _excnest_count
_lock_flag_svc:
    .long _lock_flag
_iipm_lock_svc:
    .long IIPM_LOCK
_ipmflg_svc:
    .long _ipmflg
svc_usr_r_1_svc:
    .long svc_usr_r_1
_mpcmpen_svc:
	.long MPCMPEN   /* MPUͭ */
_mpuvalid_svc:
	.long 0xaaaa0001

    .section .text_shared
    .align 4
svc_usr_r_1:
    /*
     *  R1: MPUENΥɥ쥹
     *  R2: ޥåʥС
     */
	mov.l	r2, @r1
    
    /*
     *  ipm
     */
    stc     sr, r1
    mov     #0xf0, r2
    not     r2, r2
    and     r2, r1      /* imask򥯥ꥢ */
    or      r10, r1     /* imask */
    ldc     r1, sr

    mov.l   @r15+, r10  /* r10 */
    mov.l   @r15+, r9   /* r9 */
    mov.l   @r15+, r8   /* r8 */
    lds.l   @r15+, pr   /* pr */
    rts
    nop

    /*
     *  桼Υ㳰롼
     *  ƽФ
     *  - ߶ػ߾
     *  - ø⡼ɼ¹sstk, MPU OFF
     *  - R0 = p_runtsk
     *  - R10 = ipm
     */
    .global _prepare_texrtn_utask
    .global _prepare_texrtn_utask_r
    .section .text_kernel
    .align 4
_prepare_texrtn_utask:
    /*
     *  å쥸
     */
    /*
     *  桼åλ̤å
     *  uspθ
     *  ø⡼ɻ˻Ѥ륵
     *    㳰ΤǻѤʬˤĤƤϡ
     *    桼⡼ɡMPU ONˤǼ¹Ԥ뤿ˡ
     *    ¹Ի˥åХե򸡽ФǤ
     */
    mov.l   _mpceadr4_texrtn, r1    /* r1 = 桼åνλɥ쥹 */
    mov.l   @r1, r1
    add     #4, r1
    mov.l   @(TCB_usp,r0), r2       /* r2 = usp */
    cmp/hi  r1, r2                  /* r2 > r1 ʤ */
    bt      error_nomem_texrtn      /* 顼 */
    mov     #(3*4), r3              /* size */
    cmp/hi  r2, r3                  /* r3 > r2 ʤ */
    bt      error_nomem_texrtn      /* 顼 */
    mov.l   _mpcsadr4_texrtn, r1    /* r1 = 桼åƬɥ쥹 */
    mov     r2, r4
    mov.l   @r1, r1
    sub     r3, r4                  /* r4 = usp - size */
    cmp/hi  r4, r1                  /* r1 > r4 ʤ */
    bt      error_nomem_texrtn      /* 顼 */
    nop

    /* 
     *  桼åؤ
     *                                  <- old usp
     *   ϡPR
     *   ǥѥåα֡dspflg
     *   ǥѥåػ߾֡disdsp   <- new usp
     */
    sts.l   pr, @-r2                    /* PR */
    mov.l   _dspflg_texrtn, r1          /* r1 = &dspflg */
    mov.l   @r1, r1                     /* r1 = dspflg */
    mov.l   r1, @-r2                    /* dspflg */
    mov.l   _disdsp_texrtn, r1          /* r1 = &disdsp */
    mov.l   @r1, r1                     /* r1 = disdsp */
    mov.l   r1, @-r2                    /* disdsp */
    mov.l   r2, @(TCB_usp,r0)           /* uspι */

_prepare_texrtn_utask_r:
    /*
     *  㳰롼ΰ
     */
    /* 1R4 = p_runtsk->texptn */
    /* 2R5 = p_runtsk->p_tinib->exinf */
    mov.l   @(TCB_texptn,r0), r4        /* 㳰ѥ */
    mov.l   @(TCB_p_tinib,r0), r2
    mov.l   @(TINIB_exinf,r2), r5      /* ĥ */

    /*
     *  㳰롼󤫤Ϥcall_ret_tex˻
     */
    mov.l   _call_ret_tex_texrtn, r1
    lds     r1, pr

    /*
     *  㳰롼إ׸Υƥ֤CPUå֤Ȥ
     */
    mov.l   _lock_flag_texrtn, r3
    mov     #0, r1
    mov.l   r1, @r3

    /*
     *  ø⡼ɤƥ㳰롼إ
     */
    mov.l   @(TINIB_texrtn,r2), r1      /* 㳰롼Υɥ쥹 */

    /*
     *  桼åؤڤؤ
     */
    mov.l   r15, @(TCB_ssp,r0)          /* ssp¸ */
    mov.l   @(TCB_usp,r0), r15          /* uspΥå */

    mov     #0, r2
	mov.b	r2,	@(TCB_priv_mode,r0)     /* ø⡼ɼ¹Ԥȴ */
	mov.l	r2,	@(TCB_texptn,r0)        /* p_runtsk->texptn = 0 */
	mov.b	@(TCB_enatex,r0), r3        /* p_runtsk->enatex = false */
    mov     #TCB_enatex_mask, r2
    not     r2, r2
    and     r2, r3
	mov.b	r3,	@(TCB_enatex,r0)        /* p_runtsk->enatex = false */
    
    /* 
     *  MPUͭ
     */
	mov.l	_mpcmpen_texrtn, r0
	mov.l	_mpuvalid_texrtn, r2
    mov.l   _texrtn_utask_shared_texrtn, r3
    jmp     @r3
    nop

error_nomem_texrtn:
    /*
     *  ߥ졼Ȥ줿CPU㳰Ƥ
     */
    sts.l   pr, @-r15   /* Ϥ */
	mov.l   _c_routine_emulate_exc_texrtn, r6
    mov.l   @r6, r6
	mov     #TEXCNO_EMULATE_TEXRTN, r5       						
    mov.l   _emulate_exception_entry_texrtn, r0
    jsr     @r0
    nop
    lds.l   @r15+, pr   /* Ϥ */
    rts
    nop

    .align 4
    .extern _emulate_exception_entry
_mpcsadr4_texrtn:
    .long MPCSADR4
_mpceadr4_texrtn:
    .long MPCEADR4
_call_ret_tex_texrtn:
    .long _call_ret_tex
_dspflg_texrtn:
    .long _dspflg
_disdsp_texrtn:
    .long _disdsp
_lock_flag_texrtn:
    .long _lock_flag
_emulate_exception_entry_texrtn:
    .long _emulate_exception_entry
_c_routine_emulate_exc_texrtn:
    .long  __kernel_emulate_texrtn_handler
_mpcmpen_texrtn:
	.long MPCMPEN   /* MPUͭ */
_mpuvalid_texrtn:
	.long 0xaaaa0001
_texrtn_utask_shared_texrtn:
    .long texrtn_utask_shared

    .global texrtn_utask_shared
    .section .text_shared
    .align 4
texrtn_utask_shared:
    /*
     *  R1: MPUENΥɥ쥹
     *  R2: ޥåʥС
     */
	mov.l	r2, @r0
    
    /*
     *  // cpuå
     *  ipm
     */
    stc     sr, r0
    mov     #0xf0, r2
    not     r2, r2
    and     r2, r0      /* imask򥯥ꥢ */
    or      r10, r0     /* imask */
    ldc     r0, sr

    jmp     @r1 
    nop

    .global _call_ret_tex
    .section .text_shared
    .align 4
_call_ret_tex:
    /*
     *  SR˥åȤƤipm¸
     *  ߶ػ
     */
    stc     sr, r0
    and     #0xf0, r0   /* IMASKΤ߻Ĥ */
    mov     r0, r10     /* IMASK¸ */
    stc     sr, r0
    or      #0xf0, r0   /* IMASK򥻥å */
    ldc     r0, sr

    /* 
     *  MPU̵
     */
	mov.l	_mpcmpen_ret_tex, r1
	mov.l	_mpuinvalid_ret_tex, r0
	mov.l	r0, @r1
    mov.l   _call_ret_tex_0_ret_tex, r0
    jmp     @r0
    nop

    .align 4
_call_ret_tex_0_ret_tex:
    .long _call_ret_tex_0
_mpuinvalid_ret_tex:
	.long 0xaaaa0000
_mpcmpen_ret_tex:
	.long MPCMPEN   /* MPUͭ */

#define ACVCT_ACPTN1 0
#define ACVCT_ACPTN2 4
#define USTK_pr      8
#define USTK_dspflg  4
#define USTK_disdsp  0

    .global _call_ret_tex_0
    .section .text_kernel
    .align 2
_call_ret_tex_0:
    /*
     *  ƤӽФ󥿥ƥȤʤХ顼
     */
    mov.l   _excnest_count_ret_tex, r0
    mov.l   @r0, r0
	cmp/eq  #0,	r0                      /*  ¿ųߤǤʤ */
	bf      _error_context_ret_tex      /*  ¿ųߤʤХ顼 */
    /*
     *  ƤӽФͥɥᥤʤХ顼
     */
    mov.l   _rundom_ret_tex, r2
    mov.l   @r2, r2
    tst     r2, r2
    bt      _error_context_ret_tex
    nop
    /*
     *  ƤӽФø⡼ɤʤХ顼
     */
    mov.l   _p_runtsk_ret_tex, r0
    mov.l   @r0, r0
    mov.b   @(TCB_priv_mode,r0), r1
    tst     r1, r1
    bf      _error_context_ret_tex
    nop

    /*
     *  桼åλ̤å
     *  uspθ
     *  ø⡼ɻ˻Ѥ륵
     *    㳰ǥ桼å줿ؤб
     */
    mov.l   _mpcsadr4_ret_tex, r1   /* r1 = 桼åƬɥ쥹 */
    mov     r15, r3                 /* r3 = usp */
    mov.l   @r1, r1
    cmp/hi  r3, r1                  /* r1 > r3 ʤ */
    bt      error_nomem_ret_tex     /* 顼 */
    mov     #(4*4), r1              /* size */
    addv    r1, r3                  /* r3 = usp + size: Хեȯ */
    bt      error_nomem_ret_tex     /* 顼 */
    mov.l   _mpceadr4_ret_tex, r1   /* r1 = 桼åνλɥ쥹 */
    mov.l   @r1, r1
    cmp/hi  r1, r3                  /* r3 > r1 ʤ */
    bt      error_nomem_ret_tex     /* 顼 */
    nop

    /*
     *  λǡr2 = rundom
     */
    /*
     *  CPUå
     *  ipm桼å
     *    㳰顤CPUåͥ٥ޥ
     *    ѹޤޥ꥿󤷤ؤк
     */
    mov.l    _kernel_sysstat_acvct_ret_tex, r3
    mov.l    @(ACVCT_ACPTN2,r3), r1
    tst      r1, r2                              /* r1 & r2 == 0? */
    bt       _call_ret_tex_1
    /*
     *  ꥿Υƥ֤CPUå֤Ȥ
     */
    mov.l   _lock_flag_ret_tex, r4
    mov     #0, r1
    mov.l   r1, @r4
    /*
     *  ipmͥ٥ޥ֤
     */
    mov     #IIPM_ENAALL, r10

_call_ret_tex_1:
    /*
     *  disdsp桼å
     *    㳰顤ǥѥåػߤޤ
     *    ꥿󤷤ؤк
     */
    mov.l    @(ACVCT_ACPTN1,r3), r3
    tst      r3, r2                              /* r3 & r2 == 0? */
    bt       _call_ret_tex_2
    /*
     *  disdsp桼å
     */
    mov.l   _disdsp_ret_tex, r1
    mov.l   @(USTK_disdsp,r15), r3
    mov.l   r3, @r1
    /*
     *  dspflg򹹿
     *  ͥ٥ޥ֤ΤϤʤΤǡ
     *  disdspΤߤȽǤФ褤
     *  Τᡤdisdsp򥿥㳰᤹ʤС
     *  dspflg⥿㳰
     */
    mov.l   _dspflg_ret_tex, r1
    mov.l   @(USTK_dspflg,r15), r3
    mov.l   r3, @r1

_call_ret_tex_2:
    /*
     *  p_runtsk->enatex = false
     */
	mov.b	@(TCB_enatex,r0), r1    /* 㳰ľ֤ɽФ */
    mov     #TCB_enatex_mask, r2
    not     r2, r2
    and     r2, r1
    mov.b   r1, @(TCB_enatex,r0)

    /*
     *  dspflgtrue
     */
    mov.l   _dspflg_ret_tex, r3
    mov.l   @r3, r3
    tst     r3, r3          /* dspflg == false? */
    bt      _call_ret_tex_3 /* falseʤǥѥåʤ */
    /*
     *  p_runtsk != p_schedtsk 
     */
	mov.l   _p_schedtsk_ret_tex, r3 /* r3 <- schedtsk */
	mov.l   @r3, r3
	cmp/eq  r0, r3   				/* runtsk  schedtsk  */
	bt	    _call_ret_tex_3         /* Ʊʤǥѥåʤ */
    /*
     *  CPUå֤
     */
    mov.l   _lock_flag_ret_tex, r4
    mov     #0, r1
    mov.l   r1, @r4

    mov.l   _saved_iipm_ret_tex, r4
    mov     #0, r1
    mov.l   r1, @r4

    /*
     *  SRΥå
     *  ͥγߤػ
     */
    mov.l   _iipm_cpu_lock_ret_tex, r3
    ldc     r3, sr

    /*
     *  dispatch
     */
    mov.l   _dispatch_ret_tex, r2
    jsr     @r2
    nop

    mov     #0xf0, r0   /* IMASK߶ػ߾֤ */
    ldc     r0, sr

    /*
     *  ꥿Υƥ֤CPUå֤Ȥ
     */
    mov.l   _lock_flag_ret_tex, r1
    mov     #0, r0
    mov.l   r0, @r1

_call_ret_tex_3:
    /*
	 *  α㳰װ뤫å
	 */
    mov.l   _p_runtsk_ret_tex, r0
    mov.l   @r0, r0
	mov.l	@(TCB_texptn,r0), r1    /* α㳰װɽФ */
    tst     r1, r1                  /* α㳰װ0 */
    bt      _call_ret_tex_r         /* 0ʤХ꥿ */
    nop
    mov.l   _prepare_texrtn_ret_tex, r1
    jmp     @r1                     /* 0ǤʤtexrtnƼ¹ */
    nop

_call_ret_tex_r:
    add     #USTK_pr, r15
    lds.l   @r15+, pr      /* pr */
    /*
     *  p_runtsk->enatex = true
     */
	mov.b	@(TCB_enatex,r0), r1    /* 㳰ľ֤ɽФ */
    mov     #TCB_enatex_mask, r2
    or      r2, r1
    mov.b   r1, @(TCB_enatex,r0)
    /*
     *  uspsspڤؤ
     */
    mov.l   r15, @(TCB_usp,r0)
    mov.l   @(TCB_ssp,r0), r15
    mov     #1, r1
    mov.b   r1, @(TCB_priv_mode,r0) /* p_runtsk->priv_mode = true */

    rts
    nop

    /*
     *  ret_texǥ顼Ȥʤϡ
     *  ext_tsk
     *  ext_ker
     *  ˸ƤӽФ
     */
_error_context_ret_tex:
    mov.l   _kernel_ext_tsk_ret_tex, r1
    jsr     @r1
    nop
    mov.l   _kernel_ext_ker_ret_tex, r1
    jsr     @r1
    nop

error_nomem_ret_tex:
    /*
     *  ߥ졼Ȥ줿CPU㳰Ƥ
     */
    sts.l   pr, @-r15   /* Ϥ */
	mov.l   _c_routine_emulate_exc_ret_tex, r6
    mov.l   @r6, r6
	mov     #TEXCNO_EMULATE_RET_TEX, r5       						
    mov.l   _emulate_exception_entry_ret_tex, r0
    jsr     @r0
    nop
    lds.l   @r15+, pr   /* Ϥ */
    rts
    nop

    .align 4
_excnest_count_ret_tex:
    .long _excnest_count
_rundom_ret_tex:
	.long _rundom
_mpcsadr4_ret_tex:
    .long MPCSADR4
_mpceadr4_ret_tex:
    .long MPCEADR4
_iipm_cpu_lock_ret_tex:				/* ͥ߶ػѥޥ */
	.long  IIPM_LOCK			/* ipmʳΥӥåȤϥɤ */
_kernel_sysstat_acvct_ret_tex:
    .long __kernel_sysstat_acvct
_call_ret_tex_ret_tex:
    .long _call_ret_tex
_lock_flag_ret_tex:
    .long _lock_flag
_saved_iipm_ret_tex:
    .long _saved_iipm
_dspflg_ret_tex:
    .long _dspflg
_disdsp_ret_tex:
    .long _disdsp
_p_schedtsk_ret_tex:
    .long _p_schedtsk
_p_runtsk_ret_tex:
    .long _p_runtsk
_prepare_texrtn_ret_tex:
    .long _prepare_texrtn_utask_r
_dispatch_ret_tex:
    .long _dispatch
_kernel_ext_tsk_ret_tex:
    .long __kernel_ext_tsk
_kernel_ext_ker_ret_tex:
    .long __kernel_ext_ker
_emulate_exception_entry_ret_tex:
    .long _emulate_exception_entry
_c_routine_emulate_exc_ret_tex:
    .long  __kernel_emulate_ret_tex_handler

