/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 *	
 *	Copyright (C) 2011 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *	
 */

/*
 *	ޥɥ饤СSH2AWѡ
 *	
 *	CMT0
 */

#include "kernel_impl.h"
#include <sil.h>
#include "target_timer.h"
#include "time_event.h"
#include "overrun.h"

/*
 *	ޤεư
 */
void
target_timer_initialize(intptr_t exinf)
{
	CLOCK	 cyc = TO_CLOCK(TIC_NUME, TIC_DENO) - 1;

	/*
	 *	޼ꤷޤư򳫻Ϥ롥
	 */
	/* CMT0 */
	sil_wrh_mem((void *)CM01STR,
				(sil_reh_mem((void *)CM01STR) & ~CMT0_STR));

	/* ޾ͤΥå */
	assert(cyc <= MAX_CLOCK);

	/* ʬꡢߵ */
	sil_wrh_mem((void *)CMT0CR, (CMSR_CKS_DIV32	| CMCR_CMIE));

	/* ڥޥåȤ򥻥å */
	sil_wrh_mem((void *)CMT0CMSE, (uint16_t)cyc);
	
    /* 󥿤ꥻå */
	sil_wrh_mem((void *)CMT0CNT, (uint16_t)0U);

	/* ׵򥯥ꥢ */
    x_clear_int(INTNO_TIMER);
	
    /* CMT0 */
	sil_wrh_mem((void*)CM01STR,
				(sil_reh_mem((void*)CM01STR) | CMT0_STR));

}

/*
 *	ޤ߽
 */
void
target_timer_terminate(intptr_t exinf)
{
	/* ޤ */
	sil_wrh_mem((void *)CM01STR,
				(sil_reh_mem((void *)CM01STR) & ~CMT0_STR));
	
	/* ׵򥯥ꥢ */
    x_clear_int(INTNO_TIMER);

}

/*
 *	޳ߥϥɥ
 */
void
target_timer_handler(void)
{
	/* ׵򥯥ꥢ */
    x_clear_int(INTNO_TIMER);

	i_begin_int(INTNO_TIMER);
	signal_time();					  /* ƥåζ */
	i_end_int(INTNO_TIMER);
}

#ifdef TOPPERS_TARGET_SUPPORT_OVRHDR
/*
 *	Х󥿥ޤν
 *
 *	ޤ롥
 */
void
target_ovrtimer_initialize(intptr_t exinf)
{
	/*
	 *	޼ꤹ롥
	 */
	/* CMT1 */
	sil_wrh_mem((void *)CM01STR,
				(sil_reh_mem((void *)CM01STR) & ~CMT1_STR));

	/* ʬꡢߵ */
	sil_wrh_mem((void *)CMT1CR, (CMSR_CKS_DIV512 | CMCR_CMIE));

}

/*
 *	Х󥿥ޤνλ
 *
 *	ޤưλ롥
 */
void
target_ovrtimer_terminate(intptr_t exinf)
{
	/* ޤ */
	sil_wrh_mem((void *)CM01STR,
				(sil_reh_mem((void *)CM01STR) & ~CMT1_STR));
	
	/* ׵򥯥ꥢ */
    x_clear_int(INTNO_TIMER);

}

/*
 *	Х󥿥ޤεư
 *
 *	ޤư롥
 */
void
target_ovrtimer_start(OVRTIM ovrtim)
{
	CLOCK	 cyc = OVRTIMER_CLOCK(ovrtim) - 1;

	/*
	 *	޼ꤷޤư򳫻Ϥ롥
	 */
	/* ޾ͤΥå */
	assert(cyc <= MAX_CLOCK);

	/* ڥޥåȤ򥻥å */
	sil_wrh_mem((void *)CMT1CMSE, (uint16_t)cyc);
	
    /* 󥿤ꥻå */
	sil_wrh_mem((void *)CMT1CNT, (uint16_t)0U);

	/* ׵򥯥ꥢ */
    x_clear_int(INTNO_TIMER);
	
    /* CMT1 */
	sil_wrh_mem((void*)CM01STR,
				(sil_reh_mem((void*)CM01STR) | CMT1_STR));

}

/*
 *	Х󥿥ޤ߽
 *
 *	ޤưߤ롥
 */
OVRTIM
target_ovrtimer_stop(void)
{
    OVRTIM rest;

	/* ޤ */
	sil_wrh_mem((void *)CM01STR,
				(sil_reh_mem((void *)CM01STR) & ~CMT1_STR));
	
	/* ׵򥯥ꥢ */
    x_clear_int(INTNO_TIMER);

	rest = ((OVRTIM)sil_reh_mem((void*)CMT1CMSE) - (OVRTIM)sil_reh_mem((void*)CMT1CNT));

    if(rest < 0){
        return 1;
    } else {
        return (OVRTIMER_USEC(rest + 1));
    }
}

/*
 *	Х󥿥ޤλĤ֤ɽФ
 */
OVRTIM
target_ovrtimer_get_current(void)
{
    OVRTIM rest;

	rest = ((OVRTIM)sil_reh_mem((void*)CMT1CMSE) - (OVRTIM)sil_reh_mem((void*)CMT1CNT));

    if(rest < 0){
        return 0;
    } else {
        return (OVRTIMER_USEC(rest + 1));
    }
}

/*
 *	Х󥿥޳ߥϥɥ
 */
void
target_ovrtimer_handler(void)
{
	i_begin_int(INTNO_OVRTIMER);
	call_ovrhdr();
	i_end_int(INTNO_OVRTIMER);
}

#endif /* TOPPERS_TARGET_SUPPORT_OVRHDR */


