/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 *	
 *	Copyright (C) 2011 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *	
 */

/*
 *	ޥɥ饤СSH2AWѡ
 */

#ifndef TOPPERS_TARGET_TIMER_H
#define TOPPERS_TARGET_TIMER_H

#include <sil.h>

/*
 *  CMTʥڥޥåޡ˴ϢΥ쥸
 */
#define CM01STR 0xfffec000 /* CMT0, CMT1ϥ쥸 */
#define CMT0_STR 0x0001    /* CMT0 */
#define CMT1_STR 0x0002    /* CMT1 */
#define CM23STR 0xfffec010 /* CMT2, CMT3ϥ쥸 */
#define CMT2_STR 0x0001    /* CMT2 */
#define CMT3_STR 0x0002    /* CMT3 */

#define CMT0CR 0xfffec002 /* CMT0쥸 */
#define CMT1CR 0xfffec008 /* CMT1쥸 */
#define CMT2CR 0xfffec012 /* CMT2쥸 */
#define CMT3CR 0xfffec018 /* CMT3쥸 */
#define CMCR_CMIE 0x0040  /* ߵġʥӥåȤ0ȶػߡ */
/*
 *	ʬ /8,/32,/128,/512 Τ줫
 */
#define CMSR_CKS_DIV8  0x0000U
#define CMSR_CKS_DIV32  0x0001U
#define CMSR_CKS_DIV128  0x0002U
#define CMSR_CKS_DIV512  0x0003U

#define CMT0CNT 0xfffec004 /* CMT0 */
#define CMT1CNT 0xfffec00a /* CMT1 */
#define CMT2CNT 0xfffec014 /* CMT2 */
#define CMT3CNT 0xfffec01a /* CMT3 */

#define CMT0CMSE 0xfffec006 /* CMT0ڥޥå쥸 */
#define CMT1CMSE 0xfffec00c /* CMT1ڥޥå쥸 */
#define CMT2CMSE 0xfffec016 /* CMT2ڥޥå쥸 */
#define CMT3CMSE 0xfffec01c /* CMT3ڥޥå쥸 */

#define INTNO_CMT0 142 /* CMT0ֹ */
#define INTNO_CMT1 143 /* CMT1ֹ */
#define INTNO_CMT2 144 /* CMT2ֹ */
#define INTNO_CMT3 145 /* CMT3ֹ */

/*
 *  CMT0Ѥ
 */

/*
 *	ͤɽȥߥñ̤ȤѴ
 *	1msecΥåȿ
 *	ߤꡧ
 *	  f(CPU)160MHz
 *	  f(PBA)40MHz(f(CPU)4ʬ)
 *	  CMTΥȥ32ʬ
 */
#define TIMER_CLOCK ((40000000/32) / 1000)

/*
 *	޳ߥϥɥϿΤ
 */
#define INHNO_TIMER 	INTNO_CMT0    /* ߥϥɥֹ */
#define INTNO_TIMER 	INTNO_CMT0    /* ֹ */
#define INTPRI_TIMER	(-6)		  /* ͥ */
#define INTATR_TIMER	0U			  /* ° */


#ifndef TOPPERS_TARGET_SUPPORT_OVRHDR
#define TOPPERS_TARGET_SUPPORT_OVRHDR
#endif /* TOPPERS_TARGET_SUPPORT_OVRHDR */

#ifdef TOPPERS_TARGET_SUPPORT_OVRHDR
/*
 *  CMT1Ѥ
 */

/*
 *	޳ߥϥɥϿΤ
 */
#define INHNO_OVRTIMER 	INTNO_CMT1    /* ߥϥɥֹ */
#define INTNO_OVRTIMER 	INTNO_CMT1    /* ֹ */
#define INTPRI_OVRTIMER	(-7)		  /* ͥ */
#define INTATR_OVRTIMER	0U			  /* ° */

#endif /* TOPPERS_TARGET_SUPPORT_OVRHDR */

#ifndef TOPPERS_MACRO_ONLY

/*
 *	ͤɽη
 */
typedef uint32_t	CLOCK;

/*
 *	ͤɽȥߥáñ̤ȤѴ
 *
 */
#define TO_CLOCK(nume, deno)	((CLOCK)(TIMER_CLOCK * (nume) / (deno)))
#define TO_USEC(clock)			(((SYSUTM) clock) * 1000U / TIMER_CLOCK)

/*
 *	ǤΥ޼ñ̤ɽ
 */
#define MAX_CLOCK	 ((CLOCK) 0xffffU)

/*
 *	ޤεư
 *
 *	ޤŪʥ޳׵ȯ롥
 */
extern void target_timer_initialize(intptr_t exinf);

/*
 *	ޤ߽
 *
 *	ޤưߤ롥
 */
extern void target_timer_terminate(intptr_t exinf);

/*
 *	ޤθͤɽФ
 */
Inline CLOCK
target_timer_get_current(void)
{
	return (CLOCK)(sil_reh_mem((void*)CMT0CNT));
}

/*
 *	޳׵Υå
 */
Inline bool_t
target_timer_probe_int(void)
{
    return (x_probe_int(INTNO_TIMER));
}

/*
 *	޳ߥϥɥ
 */
extern void target_timer_handler(void);

#ifdef TOPPERS_TARGET_SUPPORT_OVRHDR
/*
 *	ͤɽȥޥñ̤ȤѴ
 *	1secΥåȿ
 *	ߤꡧ
 *	  f(CPU)160MHz
 *	  f(PBA)40MHz(f(CPU)4ʬ)
 *	  CMTΥȥ512ʬ
 */
// #define OVRTIMER_CLOCK ((40000000/DIV) / 1000000)
#define OVRTIMER_CLOCK(usec) ((40 * usec) / 512)
#define OVRTIMER_USEC(clock) ((512 * clock) / 40)

/*
 *	Х󥿥ޤν
 *
 *	ޤ롥
 */
extern void target_ovrtimer_initialize(intptr_t exinf);

/*
 *	Х󥿥ޤνλ
 *
 *	ޤưλ롥
 */
extern void target_ovrtimer_terminate(intptr_t exinf);

/*
 *	Х󥿥ޤεư
 *
 *	ޤư롥
 */
extern void target_ovrtimer_start(OVRTIM ovrtim);

/*
 *	Х󥿥ޤ߽
 *
 *	ޤưߤ롥
 */
extern OVRTIM target_ovrtimer_stop(void);

/*
 *	Х󥿥ޤθͤɽФ
 */
extern OVRTIM target_ovrtimer_get_current(void);

/*
 *	Х󥿥޳ߥϥɥ
 */
extern void target_ovrtimer_handler(void);

/*
 *  Хϥɥ鵯ư롼
 */
extern void	call_ovrhdr(void);

#endif /* TOPPERS_TARGET_SUPPORT_OVRHDR */

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_TARGET_TIMER_H */
